<%@ Page Language="C#" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" >
<head>
    <title>Developer Tools</title>
    <polar:CssIncludes runat="server"/>
</head>
<body class="yui-skin-sam">
    <polar:Navigation ID="Navigation1" runat="server" />

    <div id="resourceForm" <% if(HttpContext.Current.Response.StatusCode != 200 ){%> style="display: none" <% } %> >
	<style type="text/css">
	    #devToolsTable
	    {
	        table-layout: auto;
	        width: 100%;
	        height: 50px;
	    }
	    #devToolsTable tr
	    {
	        height: 40px;
	    }
	</style>	
    <table id="devToolsTable" class="psFormTable devToolsTable" border="0" cellpadding="0" cellspacing="0" >
        <tbody>
            <tr>
                <td><input type="button" id="executeIncidentImportScriptButton" value="Execute Incident Import SQL Script" /><span> This will import demo incidents over last month. They are defined in /data/database/importIncidents.json</span></td>
            </tr>
            <tr>
                <td><input type="button" id="executeCustomScriptButton" value="Execute Developer's Custom SQL Script" /><span> This will execute develper's custom script. It contains licenses, users and other data needed for development. Note: URLs are replaced with current instance URL.</span></td>
            </tr>
            <tr>
                <td><span>Below is read only SQL script for inserting many various incidents in last month period. It is read only for copying, text entered below will not be executed.</span></td>
            </tr>
            <tr>
			    <td class="psFormCell" colspan="4">
			        <textarea id="insertIncidentsScriptTextArea" rows="25" cols="160"><%= resource.SqlInsertIncidentsScript.Value %></textarea>
			    </td>
            </tr>
            <tr>
                <td><span>Below is read only SQL script for executing developer's custom SQL script. It is read only for copying, text entered below will not be executed. Note: URLs are replaced with current instance URL.</span></td>
            </tr>
            <tr>
			    <td class="psFormCell" colspan="4">
			        <textarea id="customScriptArea" rows="25" cols="160"><%= resource.SqlCustomScript.Value %></textarea>
			    </td>
            </tr>
        </tbody>
    </table>
    </div>

    <polar:Footer ID="Footer1" runat="server" />

    <script type="text/javascript">
        var resource = <%= _jsonResRep %>
    </script>
  	<polar:Includes ID="Includes1" runat="server" />

   	<script type="text/javascript">
   	    YAHOO.util.Event.onDOMReady(function() {
   	        POLAR.View.CheckForExtraInfo();
   	        POLAR.View.Page();
   	    });

   	    POLAR.View.Page = function() {
   	        POLAR.View.setTitleAndResourceName(resource.LabelsCommon.DeveloperTools);

   	        $('#insertIncidentsScriptTextArea').focus(
   	            function() {
   	                this.select();
   	            }
   	        );

   	        $('#customScriptArea').focus(
                function() {
                    this.select();
                }
   	        );

   	        // attach POST request on execute import incdients script button just like we do on save button in standard resources
   	        new YAHOO.widget.Button('executeIncidentImportScriptButton');
   	        if ($('#executeIncidentImportScriptButton').length) {
   	            $('#executeIncidentImportScriptButton').click(POLAR.View.Page.executeImportIncidentsScript);
   	        }

   	        // attach POST request on execute custom script button just like we do on save button in standard resources
   	        new YAHOO.widget.Button('executeCustomScriptButton');
   	        if ($('#executeCustomScriptButton').length) {
   	            $('#executeCustomScriptButton').click(POLAR.View.Page.executeCustomScript);
   	        }
   	    }

   	    POLAR.View.Page.executeImportIncidentsScript = function() {
   	        // dont send scripts to server, we only needed them for reading
   	        resource.SqlInsertIncidentsScript = null;
   	        resource.SqlCustomScript = null;
   	        resource.ExecuteInsertIncidentsScript = true;
   	        resource.ExecuteCustomScript = false;

   	        var transaction = YAHOO.util.Connect.asyncRequest('POST', POLAR.View.getUri(), POLAR.View.Page.requestCallback, POLAR.View.serializeData());
   	    }

   	    POLAR.View.Page.executeCustomScript = function() {
   	        // dont send scripts to server, we only needed them for reading
   	        resource.SqlInsertIncidentsScript = null;
   	        resource.SqlCustomScript = null;
   	        resource.ExecuteInsertIncidentsScript = false;
   	        resource.ExecuteCustomScript = true;

   	        var transaction = YAHOO.util.Connect.asyncRequest('POST', POLAR.View.getUri(), POLAR.View.Page.requestCallback, POLAR.View.serializeData());
   	    }

   	    POLAR.View.Page.asyncResponse = function(request) {
   	        POLAR.View.setAsyncResponseMessage(request);
   	    }

   	    POLAR.View.Page.requestCallback = {
   	        success: POLAR.View.Page.asyncResponse,
   	        failure: POLAR.View.Page.asyncResponse,
   	        argument: POLAR.View.args
   	    };
	</script>
</body>
</html>

<script runat="server">
    DevToolsResource resource;
    string _jsonResRep;

	protected void Page_Load(object sender, EventArgs e)
    {
        PageHelper.RedirectToInstallationIfNoDatabaseFound();

        ApiHttpHandler apiHttpHandler = new ApiHttpHandler();
        ResourceHandlerResult resourceHandlerResult = apiHttpHandler.ProcessPageRequest(Context);
        _jsonResRep = resourceHandlerResult.JsonResourceRepresentation;
        resource = resourceHandlerResult.EntityResoruceRepresentation as DevToolsResource;
    }
</script>
resource.ExecuteCustomScript = true;