<%@ Page Language="C#" %>
<%@ Import namespace="Newtonsoft.Json.Linq"%>
<%@ Import namespace="Polar.ServiceDesk.WebUserInterface.ResourceDefinitions"%>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" >
<head>
    <title><%= DocumentLabels.Title %></title>
    <polar:CssIncludes runat="server"/>
</head>
<body class="yui-skin-sam">
    <polar:Navigation runat="server" />

    <div id="resourceForm" <% if(HttpContext.Current.Response.StatusCode != 200 ){%> style="display: none" <% } %> >
    <div style="text-align: right;">
		<a href="<%= resource.HistoryURL.Value %>">
			<span><%= CommonLabels.History %></span>
		</a>
		 |
		<%
            if (0 != resource.ID.Value)
            {
                bool isEntityDeleted = _documentRepository.GetByID((long)resource.ID.Value).Deleted;

                if (!isEntityDeleted && resource.Namespace.Value == null && AuthorisationHelper.GetAuthorizationOnUri("namespace/{NamespaceID}"))
                {
				    %><a href="<%= UrlHelper.GetUrl("/namespace/" + resource.ID.Value) %>">Edit</a><%
                }
                else if (!isEntityDeleted && AuthorisationHelper.GetAuthorizationOnUri("documentedit/{DocumentID}/namespace/{NamespaceID}"))
                {
				    %><a href="<%= UrlHelper.GetUrl("/documentedit/" + resource.ID.Value + "/namespace/" + resource.NamespaceID.Value) %>">Edit</a><%
                }
                else if (isEntityDeleted && resource.NamespaceID.Value == null && AuthorisationHelper.GetAuthorizationOnUri("namespace/{NamespaceID}/deleted"))
                {
				    %><a href="<%= UrlHelper.GetUrl("/namespace/" + resource.ID.Value + "/deleted") %>">Edit</a><%
                }
				else if (isEntityDeleted && AuthorisationHelper.GetAuthorizationOnUri("documentedit/{DocumentID}/namespace/{NamespaceID}/deleted"))
                {
				    %><a href="<%= UrlHelper.GetUrl("/documentedit/" + resource.ID.Value + "/namespace/" + resource.NamespaceID.Value + "/deleted") %>">Edit</a><%
                }
            }
		%>
    </div>

	<b><%= resource.Title %></b><br />
	<%
        foreach (var item in resource.Attachments.Value)
        {
            %><a href="<%= item.URI %>"><%= item.Name %></a>, <%
        }
    %>  
	<p><%= (resource.Body.Value != null) ? resource.Body.Value.Replace("<\\/script>", "</script>") : "" %></p>
	</div>

    <polar:Footer runat="server" />
    <script type="text/javascript">
        var resource = <%= _jsonResRep %>
    </script>
   	<polar:Includes runat="server" />

   	<script type="text/javascript">
   	    YAHOO.util.Event.onDOMReady(function() {
            POLAR.View.CheckForExtraInfo();
		    POLAR.View.Page();
		});

		POLAR.View.Page = function() {
		    POLAR.View.setTitleAndResourceName(resource.LabelsCommon.Document);

		}
	</script>
</body>
</html>

<script runat="server">
    DocumentResource resource;
    string _jsonResRep;

	DocumentRepository _documentRepository = IoC.Container.Resolve<DocumentRepository>();

	protected void Page_Load(object sender, EventArgs e)
    {
        PageHelper.RedirectToInstallationIfNoDatabaseFound();

        ApiHttpHandler apiHttpHandler = new ApiHttpHandler();
        ResourceHandlerResult resourceHandlerResult = apiHttpHandler.ProcessPageRequest(Context);
        _jsonResRep = resourceHandlerResult.JsonResourceRepresentation;
        resource = resourceHandlerResult.EntityResoruceRepresentation as DocumentResource;
    }
</script>