<%@ Page Language="C#" %>
<%@ Import namespace="Newtonsoft.Json.Linq"%>
<%@ Import namespace="Polar.ServiceDesk.WebUserInterface.ResourceDefinitions"%>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" >
<head>
    <title><%= DocumentLabels.Title %></title>
    <polar:CssIncludes runat="server"/>
</head>
<body class="yui-skin-sam">
    <polar:Navigation runat="server" />
    <div id="resourceForm" <% if(HttpContext.Current.Response.StatusCode != 200 ){%> style="display: none" <% } %> >
    <div class="psFormToolbar">
    <table class="formActions" border="0" cellpadding="0" cellspacing="0">
        <tbody>
        <tr>
            <td style="text-align:left">
				<div>
					<%
						if (0 == resource.ID.Value)
						{
							%>
							<input id="buttonCreateAndOpen" <% if(!PageHelper.AuthorisePostRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.CreateAndRedirectButton %>" />
							<input id="buttonCreate" <% if(!PageHelper.AuthorisePostRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.CreateButton %>" /><%
						}
						else
						{
							if (_documentRepository.GetByID((long)resource.ID.Value).Deleted)
							{
								%><input id="buttonSave" <% if(!PageHelper.AuthorisePutRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.UndeleteButton %>" /><%
							}
							else
							{
								%>
									<input id="buttonSave" <% if(!PageHelper.AuthorisePutRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.SaveButton %>" />
									<input id="buttonDelete" <% if(!PageHelper.AuthoriseDeleteRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.DeleteButton %>" />
								<%
							}
						}
					%>
					<button id="categoryButtonId" type="button"><%= CommonLabels.Category%>...</button>
				</div>
            </td>
            <td style="text-align:right" >
                <span class="primaryValue" ><%= CommonLabels.ID %>:</span>
                <input id="ID" class="primaryValue" type="text" value="<%= resource.ID %>" readonly="readonly" />
            </td>
	    <tr>
	    <tbody>
    </table>
    </div>
    <table class="psFormTable" border="0" cellpadding="0" cellspacing="0" >
        <colgroup>
	        <col class="psColon1">
	        <col>
	        <col class="psColMid">
	        <col class="psColon3">
	        <col>
	    </colgroup>
        <tbody>
            <tr>
                <td class="psFormCell psLabelRequire">
			        <span><%= CommonLabels.Title %></span>
			    </td>
			    <td class="psFormCell" colspan="4">
			        <input id="<%= resource.Title.Name %>" class="psTextbox" type="text" value="<%= resource.Title %>" />
			    </td>
            </tr>
            <tr>
                <td class="psFormCell">
			        <span><%= CommonLabels.Status%></span>
			    </td>
			    <td class="psFormCell">
			        <select id="StatusID" class="styled">
                        <%
							foreach (DocumentStatus item in _documentStatusRepository.GetAll())
                            {
								%><option value="<%= item.ID %>" <%= HtmlHelper.OptionSelect(null !=  resource.StatusID.Value && item.ID == resource.StatusID.Value) %>><%= item.Name %></option><%
                            }
                        %>
                    </select>
			    </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell">
                </td>
                <td class="psFormCell" >
                </td>
            </tr>
            
            <tr>
                <td class="psFormCell">
			        <span><%= CommonLabels.Namespaces%></span>
			    </td>
			    <td class="psFormCell">
			        <select id="NamespaceID" class="styled">
						<option value="0"></option>
                        <%
							foreach (Document item in _documentRepository.GetAllNamespaces())
                            {
								%><option value="<%= item.ID %>" <%= HtmlHelper.OptionSelect(null !=  resource.NamespaceID.Value && item.ID == resource.NamespaceID.Value) %>><%= item.Name %></option><%
                            }
                        %>
                    </select>
			    </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell">
                </td>
                <td class="psFormCell" >
                </td>
            </tr>

            <tr>
                <td class="psFormCell psBar" colSpan="5">
                    <span><%= DocumentLabels.UploadFiles %></span>
			    </td>
		    <tr>
		    <tr class="psAfterBar" ><td></td></tr>
            <tr>
				<td class="psFormCell">
                </td>
			    <td class="psFormCell" colspan="4">
					<form id="uploadform" action="action" enctype="multipart/form-data" method="post">
						<input type="file" name="uploadfile" />
						<input type="button" id="uploadfilebutton" value="<%= CommonLabels.Upload %>" />
					</form>					
					<div id="uploadfileresult" style="visibility: hidden;">
					<b><%= DocumentLabels.UploadedFileURL %>:</b>
					<a id="uploadedfile"></a>
					</div>					
			    </td>
            </tr>
            
            <tr>
                <td class="psFormCell psBar" colspan="5">
                    <span>
                        <%= CommonLabels.Attachments %>
                    </span>
                </td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell">
                </td>
                <td class="psFormCell" colspan="4">
                    <div id="attachmentStrip">
                    </div>
                </td>
            </tr>

            <tr>
                <td class="psFormCell psBar" colSpan="5">
                    <span><%= DocumentLabels.Body %></span>
			    </td>
		    <tr>
		    <tr class="psAfterBar" ><td></td></tr>
            <tr>
			    <td class="psFormCell" colspan="5">
			        <textarea id="Body" name="Body" rows="50" cols="80" style="width: 100%"><%= resource.Body %></textarea>
			    </td>
            </tr>
        </tbody>
    </table>

    </div>

    <polar:Footer runat="server" />
    <script type="text/javascript">
        var resource = <%= _jsonResRep %>
        /*Read all Category*/
        var categoriesAll = [];
        <%
            foreach (Category item in _categoryRepository.GetAll())
            {
        %>categoriesAll.push({ID:"<%= item.ID %>", Name:"<%= item.Name %>"});
        <%
            }
        %>

    </script>
   	<polar:Includes runat="server" />

   	<script type="text/javascript">
   		var originalNamespaceID = resource.NamespaceID;
   	
   		tinyMCE.init({
			mode : 'textareas',
			theme : 'advanced',
			convert_urls : true,
			relative_urls : false,
			plugins : 'safari,pagebreak,style,layer,table,save,advhr,advimage,advlink,emotions,iespell,insertdatetime,preview,media,searchreplace,print,contextmenu,paste,directionality,fullscreen,noneditable,visualchars,nonbreaking,xhtmlxtras,template,inlinepopups',
			theme_advanced_buttons1 : 'save,newdocument,|,bold,italic,underline,strikethrough,|,justifyleft,justifycenter,justifyright,justifyfull,|,styleselect,formatselect,fontselect,fontsizeselect',
			theme_advanced_buttons2 : 'cut,copy,paste,pastetext,pasteword,|,search,replace,|,bullist,numlist,|,outdent,indent,blockquote,|,undo,redo,|,link,unlink,anchor,image,cleanup,help,code,|,insertdate,inserttime,preview,|,forecolor,backcolor',
			theme_advanced_buttons3 : 'tablecontrols,|,hr,removeformat,visualaid,|,sub,sup,|,charmap,emotions,iespell,media,advhr,|,print,|,ltr,rtl,|,fullscreen',
			theme_advanced_buttons4 : 'insertlayer,moveforward,movebackward,absolute,|,styleprops,|,cite,abbr,acronym,del,ins,attribs,|,visualchars,nonbreaking,template,pagebreak',
			theme_advanced_toolbar_location : 'top',
			theme_advanced_toolbar_align : 'left',
			theme_advanced_statusbar_location : 'bottom',
			theme_advanced_resizing : true
		});

		YAHOO.util.Event.addListener(window, 'load', function() {
            POLAR.View.CheckForExtraInfo();
		    POLAR.View.Page();
		});

		POLAR.View.Page = function() {
		    POLAR.View.setTitleAndResourceName(resource.LabelsCommon.DocumentEdit);
		    POLAR.View.CategoryButton(resource.Categories, categoriesAll, "categoryButtonId"); 
		    POLAR.View.Events.addOnResourceSavedEvent(POLAR.View.Page.onOperationSuccessful);
		    
		    POLAR.View.AttachmentStrip(resource.Attachments, '<%= CommonLabels.Upload %>', '<%= CommonLabels.Delete %>', YAHOO.util.Dom.get('attachmentStrip'), '<%= UrlHelper.GetUrl("/api/attachment") %>', false);

			YAHOO.util.Event.on('uploadfilebutton', 'click', function() {
				POLAR.View.asyncUpload('uploadform', '<%= UrlHelper.GetUrl("/api/uploadfiles") %>', function(response) {
					var resrep = POLAR.View.convertAsyncResponseToObject(response);
					$("#uploadedfile").attr("href", resrep.FileURL);
					$("#uploadedfile").text(resrep.FileURL);
					$("#uploadfileresult").css("visibility", "visible");
				});
			});
		}
		
		POLAR.View.Page.onOperationSuccessful = function() {
			if(resource.NamespaceID != originalNamespaceID) {
        		document.location = BASE_URL + "documentedit/" + resource.ID + "/namespace/" + resource.NamespaceID; 
			}
        };
	</script>
</body>
</html>

<script runat="server">
    DocumentEditResource resource;
    string _jsonResRep;
	DocumentRepository _documentRepository = IoC.Container.Resolve<DocumentRepository>();
	DocumentStatusRepository _documentStatusRepository = IoC.Container.Resolve<DocumentStatusRepository>();
    CategoryRepository _categoryRepository = IoC.Container.Resolve<CategoryRepository>();

	protected void Page_Load(object sender, EventArgs e)
    {
        PageHelper.RedirectToInstallationIfNoDatabaseFound();

        ApiHttpHandler apiHttpHandler = new ApiHttpHandler();
        ResourceHandlerResult resourceHandlerResult = apiHttpHandler.ProcessPageRequest(Context);
        _jsonResRep = resourceHandlerResult.JsonResourceRepresentation;
        resource = resourceHandlerResult.EntityResoruceRepresentation as DocumentEditResource;
    }
</script>

