<%@ Page Language="C#" %>
<%@ Import namespace="Newtonsoft.Json.Linq"%>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" >
<head>
    <title><%= EmailAccountLabels.Title %></title>
    <polar:CssIncludes runat="server"/>
</head>
<body class="yui-skin-sam">
    <polar:Navigation runat="server" />
    <div id="resourceForm" <% if(HttpContext.Current.Response.StatusCode != 200 ){%> style="display: none" <% } %> >
    <div class="psFormToolbar">
    <table class="formActions" border="0" cellpadding="0" cellspacing="0">
        <tbody>
        <tr>
            <td style="text-align:left">
                <div>
                    <% if(0 == resource.ID.Value) {
                    %>                    
                    <input id="buttonCreateAndOpen" <% if(!PageHelper.AuthorisePostRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.CreateAndRedirectButton %>" />
                    <input id="buttonCreate" <% if(!PageHelper.AuthorisePostRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.CreateButton %>" />
                    <%
                    }
                    else if (resource.Deleted.Value)
                    {
                    %>
                    <input id="buttonSave" <% if(!PageHelper.AuthorisePutRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.UndeleteButton %>" />
                    <%
                    } else {
                    %>
	                <input id="buttonSave" <% if(!PageHelper.AuthorisePutRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.SaveButton %>" />
                    <input id="buttonDelete" <% if(!PageHelper.AuthoriseDeleteRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.DeleteButton %>" />
                    <%
                    }
                    %>
                </div>

            </td>
            <td style="text-align:right" >
                <span class="primaryValue" ><%= CommonLabels.ID%>:</span> <input id="<%= IncidentResource.Meta.ID.Name %>" class="primaryValue" type="text" value="<%= resource.ID %>" readonly="readonly" />
            </td>
	    <tr>
	    <tbody>
    </table>
    </div>
    <table class="psFormTable" border="0" cellpadding="0" cellspacing="0" >
        <colgroup>
	        <col class="psColon1">
	        <col>
	        <col class="psColMid">
	        <col class="psColon3">
	        <col>
	    </colgroup>
        <tbody>
            <tr>
                <td class="psFormCell psLabelRequire">
			        <span><%= CommonLabels.Name %></span>
			        <span id="<%= resource.Name.Name + "error" %>"></span>
			    </td>
			    <td class="psFormCell" colspan="3">
			        <input id="<%= resource.Name.Name %>" class="psTextbox" type="text" value="<%= resource.Name %>" />
			    </td>
            </tr>
            <tr>
			    <td class="psFormCell psBar" colspan="5"><span><%= EmailAccountLabels.EmailAutomation %></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell psLabelRequire">
					<span><%= EmailAccountLabels.EmailAutomationMode %></td>
			    </td>
			    <td class="psFormCell">
			        <select id="AutomationMode" class="styled">
                        <%
							foreach (EmailAutomationMode item in Enum.GetValues((typeof(EmailAutomationMode))))
                            {
								%><option <%= HtmlHelper.OptionSelect((long)item == resource.AutomationMode.Value) %> value="<%= (long)item %>"><%= EmailAutomationModeLabels.GetLabel(item) %></option><%
                            }
                        %>
                    </select>
			    </td>
            </tr>
            <tr>
			    <td class="psFormCell psBar" colspan="5"><span><%= EmailAccountLabels.Templates %></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell">
			        <span><%= EmailAccountLabels.IncidentTemplateID %></span>
			        <span id="<%= resource.IncidentTemplateID.Name + "error" %>"></span>
			    </td>
			    <td class="psFormCell">
			        <select id="<%= resource.IncidentTemplateID.Name %>" class="styled">
		                <% foreach (IncidentTemplate template in incidentTemplateRepository.GetAll()) {%>
		                <option value="<%= template.ID %>" <%= template.ID == resource.IncidentTemplateID.Value ? "selected=\"selected\"" : string.Empty %>><%= template.Name %></option>
		                <% } %>
	                </select>
			    </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell">
                    <span><%= EmailAccountLabels.ContactTemplateID %></span>
                    <span id="<%= resource.ContactTemplateID.Name + "error" %>"></span>
                </td>
                <td class="psFormCell">
                    <select id="<%= resource.ContactTemplateID.Name %>" class="styled">
		                <%
		                	foreach (ContactTemplate template in contactTemplateRepository.GetAllNotDeletedTemplates())
							{
								%><option value="<%= template.ID %>" <%= template.ID == resource.ContactTemplateID.Value ? "selected=\"selected\"" : string.Empty %>><%= template.Name %></option><%
							}
                    	%>
	                </select>
                </td>
            </tr>
            <tr>
			    <td class="psFormCell psBar" colspan="5"><span><%= EmailAccountLabels.PopSettings %></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell">
					<span><%= EmailAccountLabels.EnablePOP3 %></span>
			    </td>
			    <td class="psFormCell">
					<input type="radio" id="radio-enablepop3" name="group-enablepop3" <%= resource.EnablePOP3.Value ? "checked" : string.Empty %>>
			    </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell"></td>
			    <td class="psFormCell"></td>
            </tr>
            <tr>
                <td class="psFormCell">
					<span><%= EmailAccountLabels.DisablePOP3%></span>
			    </td>
			    <td class="psFormCell">
					<input type="radio" id="radio-disablepop3"name="group-enablepop3" <%= !resource.EnablePOP3.Value ? "checked" : string.Empty %>>
			    </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell"></td>
			    <td class="psFormCell"></td>
            </tr>

            <tr>
                <td class="psFormCell">
			        <span><%= EmailAccountLabels.PopServer %></span>
			        <span id="<%= resource.PopServer.Name + "error" %>"></span>
			    </td>
			    <td class="psFormCell">
			        <input id="<%= resource.PopServer.Name %>" class="psTextbox" type="text" value="<%= resource.PopServer %>" />
			    </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell">
                    <span><%= EmailAccountLabels.PopPort %></span>
                    <span id="<%= resource.PopPort.Name + "error" %>"></span>
                </td>
                <td class="psFormCell">
                    <input id="<%= resource.PopPort.Name %>" class="psTextbox" type="text" value="<%= resource.PopPort %>" />
                </td>
            </tr>
            <tr>
                <td class="psFormCell">
			        <span><%= EmailAccountLabels.PopUsername %></span>
			        <span id="<%= resource.PopUsername.Name + "error" %>"></span>
			    </td>
			    <td class="psFormCell">
			        <input id="<%= resource.PopUsername.Name %>" class="psTextbox" type="text" value="<%= resource.PopUsername %>" />
			    </td>
			    <td class="psFormMid"></td>
                <td class="psFormCell">
			        <span><%= EmailAccountLabels.DeleteEmails%></span>
			        <span id="<%= resource.DeleteEmails.Name + "error" %>"></span>
			    </td>
			    <td class="psFormCell">
			        <input id="<%= resource.DeleteEmails.Name %>" name="<%= resource.DeleteEmails.Name %>" type="checkbox" <%= resource.DeleteEmails.Value ? "checked" : string.Empty %> />
			    </td>
            </tr>
            <tr>
                <td class="psFormCell">
                    <span><%= EmailAccountLabels.PopPassword%></span>
                    <span id="<%= resource.PopPassword.Name + "error" %>"></span>
                </td>
                <td class="psFormCell">
                    <input id="<%= resource.PopPassword.Name %>" class="psTextbox" type="text" value="<%= resource.PopPassword %>" />
                </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell">
                    <span><%= EmailAccountLabels.DeleteEmailsAfter %></span>
                    <span id="<%= resource.DeleteEmailsAfter.Name + "error" %>"></span>
                </td>
                <td class="psFormCell">
                    <input id="<%= resource.DeleteEmailsAfter.Name %>" class="psTextbox" type="text" value="<%= resource.DeleteEmailsAfter %>" />
                </td>
            </tr>
            <tr>
                <td class="psFormCell">
			    </td>
			    <td class="psFormCell">
			    </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell">
                    <span><%= EmailAccountLabels.UseSsl%></span>
                    <span id="<%= resource.PopUseSsl.Name + "error" %>"></span>
                </td>
                <td class="psFormCell">
                    <input id="<%= resource.PopUseSsl.Name %>" name="<%= resource.PopUseSsl.Name %>" type="checkbox" <%= resource.PopUseSsl.Value ? "checked" : string.Empty %> />
                </td>
            </tr>

            <tr>
			    <td class="psFormCell psBar" colspan="5"><span><%= EmailAccountLabels.ImapSettings %></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell">
					<span><%= EmailAccountLabels.EnableIMAP %></span>
			    </td>
			    <td class="psFormCell">
					<input type="radio" id="radio-enableimap" name="group-enableimap" <%= resource.EnableIMAP.Value ? "checked" : string.Empty %>>
			    </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell"></td>
			    <td class="psFormCell"></td>
            </tr>
            <tr>
                <td class="psFormCell">
					<span><%= EmailAccountLabels.DisableIMAP%></span>
			    </td>
			    <td class="psFormCell">
					<input type="radio" id="radio-disableimap"name="group-enableimap" <%= !resource.EnableIMAP.Value ? "checked" : string.Empty %>>
			    </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell"></td>
			    <td class="psFormCell"></td>
            </tr>

            <tr>
                <td class="psFormCell">
			        <span><%= EmailAccountLabels.ImapServer %></span>
			    </td>
			    <td class="psFormCell">
			        <input id="<%= resource.ImapServer.Name %>" class="psTextbox" type="text" value="<%= resource.ImapServer %>" />
			    </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell">
                    <span><%= EmailAccountLabels.ImapPort %></span>
                </td>
                <td class="psFormCell">
                    <input id="<%= resource.ImapPort.Name %>" class="psTextbox" type="text" value="<%= resource.ImapPort %>" />
                </td>
            </tr>
            <tr>
                <td class="psFormCell">
			        <span><%= EmailAccountLabels.ImapUsername %></span>
			    </td>
			    <td class="psFormCell">
			        <input id="<%= resource.ImapUsername.Name %>" class="psTextbox" type="text" value="<%= resource.ImapUsername %>" />
			    </td>
			    <td class="psFormMid"></td>
                <td class="psFormCell">
			    </td>
			    <td class="psFormCell">
			    </td>
            </tr>
            <tr>
                <td class="psFormCell">
                    <span><%= EmailAccountLabels.ImapPassword%></span>
                </td>
                <td class="psFormCell">
                    <input id="<%= resource.ImapPassword.Name %>" class="psTextbox" type="text" value="<%= resource.ImapPassword %>" />
                </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell">
					<span><%= EmailAccountLabels.ImapFolders %></span>
                </td>
                <td class="psFormCell">
					<input id="<%= resource.ImapFolders.Name %>" class="psTextbox" type="text" value="<%= resource.ImapFolders %>" />
                </td>
            </tr>
            <tr>
                <td class="psFormCell">
			    </td>
			    <td class="psFormCell">
			    </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell">
                    <span><%= EmailAccountLabels.ImapUseSsl%></span>
                </td>
                <td class="psFormCell">
                    <input id="<%= resource.ImapUseSsl.Name %>" name="<%= resource.ImapUseSsl.Name %>" type="checkbox" <%= resource.ImapUseSsl.Value ? "checked" : string.Empty %> />
                </td>
            </tr>

            <tr>
			    <td class="psFormCell psBar" colspan="5"><span><%= EmailAccountLabels.SmtpSettings %></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell">
					<span><%= EmailAccountLabels.EnableSMTP %></span>
			    </td>
			    <td class="psFormCell">
					<input type="radio" id="radio-enablesmtp" name="group-enablesmtp" <%= resource.EnableSMTP.Value ? "checked" : string.Empty %>>
			    </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell"></td>
			    <td class="psFormCell"></td>
            </tr>
            <tr>
                <td class="psFormCell">
					<span><%= EmailAccountLabels.DisableSMTP %></span>
			    </td>
			    <td class="psFormCell">
					<input type="radio" id="radio-disablesmtp"name="group-enablesmtp" <%= !resource.EnableSMTP.Value ? "checked" : string.Empty %>>
			    </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell"></td>
			    <td class="psFormCell"></td>
            </tr>

            <tr>
                <td class="psFormCell">
			        <span><%= EmailAccountLabels.SmtpServer %></span>
			        <span id="<%= resource.SmtpServer.Name + "error" %>"></span>
			    </td>
			    <td class="psFormCell">
			        <input id="<%= resource.SmtpServer.Name %>" class="psTextbox" type="text" value="<%= resource.SmtpServer %>" />
			    </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell">
                    <span><%= EmailAccountLabels.SmtpPort %></span>
                    <span id="<%= resource.SmtpPort.Name + "error" %>"></span>
                </td>
                <td class="psFormCell">
                    <input id="<%= resource.SmtpPort.Name %>" class="psTextbox" type="text" value="<%= resource.SmtpPort %>" />
                </td>
            </tr>
            <tr>
			    <td class="psFormCell">
                    <span><%= EmailAccountLabels.SmtpUsername %></span>
                    <span id="<%= resource.SmtpUsername.Name + "error" %>"></span>
                </td>
                <td class="psFormCell">
                    <input id="<%= resource.SmtpUsername.Name %>" class="psTextbox" type="text" value="<%= resource.SmtpUsername %>" />
                </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell">
			        <span><%= EmailAccountLabels.SenderEmailAddress %></span>
			        <span id="<%= resource.SenderEmailAddress.Name + "error" %>"></span>
			    </td>
			    <td class="psFormCell">
			        <input id="<%= resource.SenderEmailAddress.Name %>" class="psTextbox" type="text" value="<%= resource.SenderEmailAddress %>" />
			    </td>
            </tr>
            <tr>
                <td class="psFormCell">
			        <span><%= EmailAccountLabels.SmtpPassword %></span>
			    </td>
			    <td class="psFormCell">
			        <input id="<%= resource.SmtpPassword.Name %>" class="psTextbox" type="text" value="<%= resource.SmtpPassword %>" />
			    </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell">
                    <span><%= EmailAccountLabels.SmtpUseSsl %></span>
                </td>
                <td class="psFormCell">
                    <input id="<%= resource.SmtpUseSsl.Name %>" name="<%= resource.SmtpUseSsl.Name %>" type="checkbox" <%= resource.SmtpUseSsl.Value ? "checked" : string.Empty %> />
                </td>
            </tr>
            <tr>
                <td class="psFormCell">
			    </td>
			    <td class="psFormCell">
			    </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell">
                    <span><%= EmailAccountLabels.SmtpUseTls%></span>
                </td>
                <td class="psFormCell">
                    <input id="<%= resource.SmtpUseTls.Name %>" name="<%= resource.SmtpUseTls.Name %>" type="checkbox" <%= resource.SmtpUseTls.Value ? "checked" : string.Empty %> />
                </td>
            </tr>
        </tbody>
    </table>
    </div>

    <polar:Footer runat="server" />
    <script type="text/javascript">
        var resource = <%= _jsonResRep %>
    </script>
    <polar:Includes runat="server" />

    <script type="text/javascript">
        YAHOO.util.Event.onDOMReady(function() {
            POLAR.View.CheckForExtraInfo();
            POLAR.View.Page();
        });

        POLAR.View.Page = function() {
            POLAR.View.setTitleAndResourceName(resource.LabelsCommon.EmailAccount);

            var disablePOP3 = function() {
				$("#<%= resource.PopServer.Name %>").attr('disabled','disabled');
				$("#<%= resource.PopPort.Name %>").attr('disabled','disabled');
				$("#<%= resource.PopUsername.Name %>").attr('disabled','disabled');
				$("#<%= resource.DeleteEmails.Name %>").attr('disabled','disabled');
				$("#<%= resource.PopPassword.Name %>").attr('disabled','disabled');
				$("#<%= resource.DeleteEmailsAfter.Name %>").attr('disabled','disabled');
				$("#<%= resource.PopUseSsl.Name %>").attr('disabled','disabled');
            };

            var enablePOP3 = function() {
				disableIMAP();

				$("#<%= resource.PopServer.Name %>").removeAttr('disabled');
				$("#<%= resource.PopPort.Name %>").removeAttr('disabled');
				$("#<%= resource.PopUsername.Name %>").removeAttr('disabled');
				$("#<%= resource.DeleteEmails.Name %>").removeAttr('disabled');
				$("#<%= resource.PopPassword.Name %>").removeAttr('disabled');
				$("#<%= resource.DeleteEmailsAfter.Name %>").removeAttr('disabled');
				$("#<%= resource.PopUseSsl.Name %>").removeAttr('disabled');
            };

            var disableIMAP = function() {
				$("#<%= resource.ImapServer.Name %>").attr('disabled','disabled');
				$("#<%= resource.ImapPort.Name %>").attr('disabled','disabled');
				$("#<%= resource.ImapUsername.Name %>").attr('disabled','disabled');
				$("#<%= resource.ImapPassword.Name %>").attr('disabled','disabled');
				$("#<%= resource.ImapUseSsl.Name %>").attr('disabled','disabled');
				$("#<%= resource.ImapFolders.Name %>").attr('disabled','disabled');
            };

            var enableIMAP = function() {
				disablePOP3();

				$("#<%= resource.ImapServer.Name %>").removeAttr('disabled');
				$("#<%= resource.ImapPort.Name %>").removeAttr('disabled');
				$("#<%= resource.ImapUsername.Name %>").removeAttr('disabled');
				$("#<%= resource.ImapPassword.Name %>").removeAttr('disabled');
				$("#<%= resource.ImapUseSsl.Name %>").removeAttr('disabled');
				$("#<%= resource.ImapFolders.Name %>").removeAttr('disabled');
            };

            var disableSMTP = function() {
				$("#<%= resource.SmtpServer.Name %>").attr('disabled','disabled');
				$("#<%= resource.SmtpPort.Name %>").attr('disabled','disabled');
				$("#<%= resource.SmtpUsername.Name %>").attr('disabled','disabled');
				$("#<%= resource.SmtpPassword.Name %>").attr('disabled','disabled');
				$("#<%= resource.SmtpUseSsl.Name %>").attr('disabled','disabled');
				$("#<%= resource.SmtpUseTls.Name %>").attr('disabled','disabled');
				$("#<%= resource.SenderEmailAddress.Name %>").attr('disabled','disabled');
            };

            var enableSMTP = function() {
				$("#<%= resource.SmtpServer.Name %>").removeAttr('disabled');
				$("#<%= resource.SmtpPort.Name %>").removeAttr('disabled');
				$("#<%= resource.SmtpUsername.Name %>").removeAttr('disabled');
				$("#<%= resource.SmtpPassword.Name %>").removeAttr('disabled');
				$("#<%= resource.SmtpUseSsl.Name %>").removeAttr('disabled');
				$("#<%= resource.SmtpUseTls.Name %>").removeAttr('disabled');
				$("#<%= resource.SenderEmailAddress.Name %>").removeAttr('disabled');
            };

            if(resource.EnablePOP3 == true) {
				$("#radio-enablepop3").attr('checked','checked');
                $("#radio-disableimap").attr('checked','checked');
				disableIMAP();
            }
            else if(resource.EnableIMAP == true) {
				$("#radio-enableimap").attr('checked','checked');
                $("#radio-disablepop3").attr('checked','checked');
				disablePOP3();
            }
            else {
				$("#radio-disablepop3").attr('checked','checked');
				$("#radio-disableimap").attr('checked','checked');
				disableIMAP();
				disablePOP3();
            }

            if(resource.EnableSMTP == true) {
				$("#radio-enablesmtp").attr('checked','checked');
            }
            else {
				$("#radio-disablesmtp").attr('checked','checked');
				disableSMTP();
            }            
            
            $("#SmtpUseSsl").click(function() {
                if (this.checked) {
                    /*resource.SmtpUseSsl = true;
                    resource.SmtpUseTls = false;*/

                    $("#SmtpUseTls").removeAttr('checked');
                }
            });

            $("#SmtpUseTls").click(function() {
                if (this.checked) {
                    /*resource.SmtpUseSsl = false;
                    resource.SmtpUseTls = true;*/

                    $("#SmtpUseSsl").removeAttr('checked');
                }
            });

            $("#radio-enablepop3").click(function() {
                if (this.checked) {
                    resource.EnablePOP3 = true;
                    resource.EnableIMAP = false;

                    $("#radio-disableimap").attr('checked','checked');
                    enablePOP3();
                }
            });

            $("#radio-disablepop3").click(function() {
                if (this.checked) {
                    resource.EnablePOP3 = false;
                    disablePOP3();
                }
            });

             $("#radio-enableimap").click(function() {
                if (this.checked) {
                    resource.EnableIMAP = true;
                    resource.EnablePOP3 = false;

                    $("#radio-disablepop3").attr('checked','checked');
                    enableIMAP();
                }
            });

            $("#radio-disableimap").click(function() {
                if (this.checked) {
                    resource.EnableIMAP = false;
                    disableIMAP();
                }
            });

             $("#radio-enablesmtp").click(function() {
                if (this.checked) {
                    resource.EnableSMTP = true;
                    enableSMTP();
                }
            });

            $("#radio-disablesmtp").click(function() {
                if (this.checked) {
                    resource.EnableSMTP = false;
                    disableSMTP();
                }
            });
        }
    </script>

    <script runat="server">
        EmailAccountResource resource;
		ContactTemplateRepository contactTemplateRepository = IoC.Container.Resolve<ContactTemplateRepository>();
        IncidentTemplateRepository incidentTemplateRepository = IoC.Container.Resolve<IncidentTemplateRepository>();

        string _jsonResRep;

	    protected void Page_Load(object sender, EventArgs e)
        {
            PageHelper.RedirectToInstallationIfNoDatabaseFound();

            ApiHttpHandler apiHttpHandler = new ApiHttpHandler();
            ResourceHandlerResult resourceHandlerResult = apiHttpHandler.ProcessPageRequest(Context);
            _jsonResRep = resourceHandlerResult.JsonResourceRepresentation;
            resource = resourceHandlerResult.EntityResoruceRepresentation as EmailAccountResource;
        }
    </script>
</body>
</html>

