﻿<%@ Page Language="C#" %>
<%@ Import namespace="Polar.ServiceDesk.WebUserInterface.ResourceDefinitions"%>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" >
<head>
    <title><%= AdminEmailLabels.Title%></title>
    <polar:CssIncludes runat="server"/>
</head>

<body class="yui-skin-sam">
    <polar:Navigation runat="server" />
    
    <div id="resourceForm" <% if(HttpContext.Current.Response.StatusCode != 200){%> style="display: none" <% } %> >
    <div id="filter">
		<input id="textsearch" class="ps-filter-textsearch textboxMiddle" type="text" />		
		<input id="buttonGo" class="ps-filter-gobutton" type="button" value="<%= CommonLabels.Search %>" />				
    </div>    
    <div class="desktopTable">
        <div class="desktopTableActions">
			<%
				if (PageHelper.GetRelativeURL().Contains("/deleted"))
				{
					%><input id="undeleteButton" type="button" value="<%= CommonLabels.UndeleteButton %>" /><%
				}
				else
				{
					%>
						<input id="createIncidentButton" type="button" value="<%= AdminEmailLabels.CreateIncident %>" />
						<select id="createIncidentMenu" name="createIncidentMenu" style="display: none"> 
							<%
								foreach (IncidentTemplate template in PageHelper.GetIncidentTemplatesForLoggedInUser())
								{
									%><option value="<%= template.ID %>"><%= template.Name %></option><%
								}
							%>
						</select>
						<input id="deleteButton" type="button" value="<%= CommonLabels.DeleteButton %>" />
					<%
				}
			%>
        </div>
        <div id="dataTableContainer" class="yui-skin-sam"></div>
    </div>
    </div>

    <polar:Footer runat="server" />
    <script type="text/javascript">
        var resource = <%= _jsonResRep %>
    </script>
    <polar:Includes runat="server" />

    <script type="text/javascript">
		var dataTable;  //MUST be outside of function for proper working of selectOrUnselectAllCheckboxes function		
        YAHOO.util.Event.onDOMReady( function() {
            POLAR.View.CheckForExtraInfo();
		    POLAR.View.Page();
		});

		POLAR.View.Page = function() {
		    POLAR.View.setTitleAndResourceName(resource.LabelsCommon.Emails);
			POLAR.View.Page.initializeGrid();

			var filter = new POLAR.View.Filter(YAHOO.util.Dom.get('filter'), {
                viewUrl: '<%= UrlHelper.GetUrl("/api/filter") %>',
                args: [
                    { id: 'textsearch', urlValueName: 'textsearch', type: 'textbox' }
                ],
                onGetArguments: function(args) {
                },
                onSetArguments: function(args) {
                }
            });
        };

        POLAR.View.Page.initializeGrid = function() {
            var dataSource = POLAR.View.DataTable.createDataSource(resource);
            dataSource.responseSchema = {
                resultsList: 'Items',
                fields: [{ key: '<%= EmailResource.Meta.ID.Name %>', parser: YAHOO.util.DataSource.parseNumber },
		         '<%= EmailResource.Meta.FromEmail.Name %>',
		         '<%= EmailResource.Meta.Subject.Name %>',
		         '<%= EmailResource.Meta.IncidentID.Name %>',
		         { key: '<%= EmailResource.Meta.ReceivedOn.Name %>', parser: POLAR.View.DateTime.stringToDate },
		         '<%= EmailResource.Meta.URL.Name %>']
            };

            var formatHasIncident = function(elCell, oRecord, oColumn, oData) {
                var slika = document.createElement("div");
                slika.innerHTML = '<a href=\"' + '<%=UrlHelper.GetUrl("/incident/") %>' + oRecord._oData.IncidentID + '\">Incident</a>';
                //alert(slika.innerHTML);
                //slika.setAttribute("href", <%=ResolveUrl("/incident/") %> + oRecord._oData.IncidentID);
                //slika.className = 'checkmark';
                if (oRecord._oData.IncidentID != 0) {
                    elCell.appendChild(slika);
                }
            }

            dataTable = new YAHOO.widget.DataTable('dataTableContainer', [
				{ label: '<input class="selectall" type="checkbox" onclick="POLAR.View.DataTable.selectOrUnselectAllCheckboxes(this, dataTable)" />', formatter: YAHOO.widget.DataTable.formatCheckbox, resizeable: true },
				{ key: '<%= EmailResource.Meta.ID.Name %>', label: '<%= CommonLabels.ID %>', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
				{ key: '<%= EmailResource.Meta.Subject.Name %>', label: '<%= AdminEmailLabels.Subject %>', sortable: true, resizeable: true, formatter: POLAR.View.DataTable.formatUrl },
				{ key: '<%= EmailResource.Meta.FromEmail.Name %>', label: '<%= AdminEmailLabels.FromEmail %>', sortable: true, resizeable: true },
				{ key: '', label: '<%= AdminEmailLabels.EmailHasIncident %>', width: 75, formatter: formatHasIncident },
				{ key: '<%= EmailResource.Meta.ReceivedOn.Name %>', label: '<%= AdminEmailLabels.ReceivedOn %>', sortable: true, resizeable: true, formatter: POLAR.View.DataTable.formatDate }
			], dataSource, {
			    sortedBy: { key: '<%= EmailResource.Meta.ID.Name %>', dir: YAHOO.widget.DataTable.CLASS_DESC },
			    draggableColumns: true,
			    paginator: POLAR.View.DataTable.createDefaultPaginator()
			});

            POLAR.View.DataTable.configDataTable(dataTable);

            POLAR.View.DataTable.configDeleteUndelete({
                dataTable: dataTable,
                dataTableItems: resource.Items,
                dataTableDeleteButton: YAHOO.util.Dom.get('deleteButton'),
                dataTableUndeleteButton: YAHOO.util.Dom.get('undeleteButton')
            });

			// convert email to incident
            if ($('#createIncidentButton').length) {
                var createIncidentButton;
                
                var createIncidentsFromEmails = function(p_sType, p_aArgs) {
					var templateId = $("#createIncidentMenu").val();
					
					if(null != p_aArgs) {
						var oEvent = p_aArgs[0],	//	DOM event
							oMenuItem = p_aArgs[1];	//	MenuItem instance that was the target of the event
						
						if(oMenuItem) {
							templateId = oMenuItem.value;
						}
					}
					
					var records = dataTable.getRecordSet().getRecords();
					var items = new Array();
					
					for (var recordIndex = 0; recordIndex < records.length; recordIndex++) {
						var record = dataTable.getRecord(records[recordIndex]);
						var id = record.getData('ID');
						var uri = record.getData('URI');
						var rowEle = dataTable.getTrEl(record);

						if (rowEle != null) {
							var checkboxes = YAHOO.util.Dom.getElementsBy(function(ele) {
								return ele.type == 'checkbox';
							}, undefined, rowEle);

							if (checkboxes.length > 0) {
								var checkbox = checkboxes[0];
								if (checkbox && checkbox.checked) {
									items.push({
										url: '<%=UrlHelper.GetUrl("/api/incident/template/") %>' + templateId + '/email/' + id,
										checkbox: checkbox
									});
								}
							}
						}
					}

					$.each(items, function(itemKey, itemVal) {
						var createFunc = function(item) {
							POLAR.View.asyncPost(item.url, "", function(response) {
								if (response.Errors.length == 0) {
									item.checkbox.checked = false;
								}
							});
						};

						createFunc(itemVal);
					});
				};
                
                if($("#createIncidentMenu option").size() == 1) {
					createIncidentButton = new YAHOO.widget.Button("createIncidentButton");					
					createIncidentButton.subscribe("click", createIncidentsFromEmails);
                } else {
					createIncidentButton = new YAHOO.widget.Button("createIncidentButton", {
						type: "menu",
						menu: "createIncidentMenu" });
						
					createIncidentButton.getMenu().subscribe("click", createIncidentsFromEmails);
                }
            }

            //var createIncidentsButton = YAHOO.util.Dom.get('createIncidentButton');

            //if (createIncidentsButton != null && createIncidentsButton != undefined) {
            //    YAHOO.util.Event.addListener(createIncidentsButton, 'click', POLAR.View.DataTable.createIncidentsFromEmails, argsForIncCreation);
            //}

            //POLAR.View.createMenuOnTable(dataTable, 'dataTableContainer');
            //set with on first and second colon for beter visula efect
            $("#dataTableContainer table colgroup col:lt(2)").css('width', '10px');

            var controlAndQueryItems = { 'entities': [
                    { 'id': '_textsearch', 'queryVariable': 'textsearch', 'control': 'textbox' },
                    { 'id': '_incidenttemplate', 'queryVariable': 'incidenttemplate', 'control': 'textbox' },
                    { 'id': '_contacttemplate', 'queryVariable': 'contacttemplate', 'control': 'textbox' }
                ]
            };

            YAHOO.util.Event.addListener(YAHOO.util.Dom.get('_gobutton'), 'click', function() { POLAR.View.CreateUrlAndCallUrl(controlAndQueryItems); });
            POLAR.View.OnLoadFillControlFromUrlQuery(controlAndQueryItems);
        };
    </script>
</body>
</html>

<script runat="server">
    string _jsonResRep;

	protected void Page_Load(object sender, EventArgs e)
	{
        ApiHttpHandler apiHttpHandler = new ApiHttpHandler();
        ResourceHandlerResult responsePageRequest = apiHttpHandler.ProcessPageRequest(Context);
        _jsonResRep = responsePageRequest.JsonResourceRepresentation;
    }
</script>