<%@ Page Language="C#" %>
<%@ Import namespace="Newtonsoft.Json.Linq"%>
<%@ Import namespace="Polar.ServiceDesk.WebUserInterface.ResourceDefinitions"%>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" >
<head>
    <title><%= CommonLabels.ImportContacts %></title>
    <polar:CssIncludes runat="server"/>
</head>
<body class="yui-skin-sam">
    <polar:Navigation runat="server" />
    <div id="resourceForm" <% if(HttpContext.Current.Response.StatusCode != 200 ){%> style="display: none" <% } %> >
    <div class="psFormToolbar">
    <table class="formActions" border="0" cellpadding="0" cellspacing="0">
        <tbody>
        <tr>
            <td style="text-align:left">
                <div>
                    <input id="buttonCreate" <% if(!PageHelper.AuthorisePostRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.Import %>" />
                    <input id="buttonSave" <% if(!PageHelper.AuthorisePutRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.Export %>" />
                </div>
            </td>
            <td style="text-align:right" >
            </td>
	    <tr>
	    </tbody>
    </table>
    </div>
    <table class="psFormTable" border="0" cellpadding="0" cellspacing="0" >
        <colgroup>
	        <col class="psColon1">
	        <col>
	        <col class="psColMid">
	        <col class="psColon3">
	        <col>
	    </colgroup>
        <tbody>
            <tr>
                <td class="psFormCell">
					<span><%= CommonLabels.ContactTemplate%></span>
			    </td>
			    <td class="psFormCell">
					<select id="ContactTemplate.ID" class="styled">
		                <%
		                	foreach (ContactTemplate template in contactTemplateRepository.GetAllNotDeletedTemplates())
							{
								%><option value="<%= template.ID %>" <%= template.ID == resource.ContactTemplate.Value.ID.Value ? "selected=\"selected\"" : string.Empty %>><%= template.Name %></option><%
							}
                    	%>
	                </select>
			    </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell">
                </td>
                <td class="psFormCell">
                </td>
            </tr>
            <tr>
                <td class="psFormCell psBar" colspan="5">
                    <span><%= CommonLabels.Translation %></span>
                </td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
			    <td class="psFormCell" colspan="5">
					<div id="translationTable">
						<table border="0" cellpadding="0" cellspacing="0">
							<tbody class="ps-translationtable-rows">
								<tr>
									<td>Help Desk</td>
									<td>CSV</td>
								</tr>
								<tr class="ps-translationtable-row" style="visibility: hidden">
									<td><input class="ps-translationtable-helpdeskfield " readonly type="text" value="" /></td>
									<td><input class="ps-translationtable-activedirectoryfield psTextbox" type="text" value="" /></td>
								</tr>
							</tbody>
						</table>
						<span><%= CommonLabels.TranslationTableDescrtiption %></span>
						<input id="Translation" class="ps-translationtable-translation psTextbox" type="hidden" value="<%= resource.Translation %>" />
					</div>
			    </td>
            </tr>
            <tr>
                <td class="psFormCell psBar" colspan="5">
                    <span><%= CommonLabels.CSVData %></span>
                </td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
			    <td class="psFormCell" colspan="5">
			        <textarea class="psTextarea expand150-600 resizable"  id="<%= resource.File.Name %>"><%= resource.File %></textarea>
			    </td>
            </tr>
        </tbody>
    </table>
    </div>

    <polar:Footer runat="server" />

    <script type="text/javascript">
        var resource = <%= _jsonResRep %>
    </script>
   	<polar:Includes runat="server" />

   	<script type="text/javascript">
   	    YAHOO.util.Event.addListener(window, 'load', function() {
   	        POLAR.View.CheckForExtraInfo();
		    POLAR.View.Page();
		});

		POLAR.View.Page = function() {
		    POLAR.View.setTitleAndResourceName(resource.LabelsCommon.ImportContactsFromFile);
			var translationTable = new POLAR.View.TranslationTable(YAHOO.util.Dom.get('translationTable'), [
				{ to: 'UserName' },
				{ to: 'Email' },
				{ to: 'FirstName' },
				{ to: 'LastName' },
				{ to: 'Title' },
				{ to: 'Office' },
				{ to: 'Description' },
				{ to: 'WebPage' },
				{ to: 'Street' },
				{ to: 'City' },
				{ to: 'StateProvince' },
				{ to: 'PoBox' },
				{ to: 'ZipPostalCode' },
				{ to: 'TelephoneNumber' },
				{ to: 'TelephoneHome' },
				{ to: 'TelephonePage' },
				{ to: 'TelephoneMobile' },
				{ to: 'TelephoneFax' },
				{ to: 'Notes' }
			]);

			YAHOO.util.Event.addListener(YAHOO.util.Dom.get('importUsers'), 'click', POLAR.View.Page.importUsers);
		};
	</script>

	<script runat="server">
		ImportContactsFromFileResource resource;
		ContactTemplateRepository contactTemplateRepository = IoC.Container.Resolve<ContactTemplateRepository>();
        string _jsonResRep;

		protected void Page_Load(object sender, EventArgs e)
        {
            PageHelper.RedirectToInstallationIfNoDatabaseFound();

            ApiHttpHandler apiHttpHandler = new ApiHttpHandler();
            ResourceHandlerResult resourceHandlerResult = apiHttpHandler.ProcessPageRequest(Context);
            _jsonResRep = resourceHandlerResult.JsonResourceRepresentation;
			resource = resourceHandlerResult.EntityResoruceRepresentation as ImportContactsFromFileResource;
		}
	</script>
</body>
</html>