<%@ Page Language="C#" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" >
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />        
    <polar:CssIncludes runat="server"/>    
    <link rel="icon" type="image/png" href="/favicon.png" />    
</head>
<body class="yui-skin-sam">
    <polar:Navigation runat="server" />
    <div id="resourceForm" <% if(HttpContext.Current.Response.StatusCode != 200 ){%> style="display: none" <% } %> >
    <div class="psFormToolbar">
    <table class="formActions" border="0" cellpadding="0" cellspacing="0">
        <tbody>
            <tr>
                <td style="text-align: left">
                    <div>
                        <%
                            if (0 == resource.ID.Value)
                            {
								%>
									<input id="buttonCreateAndOpen" <% if(!PageHelper.AuthorisePostRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.CreateAndRedirectButton %>" />
									<input id="buttonCreate" <% if(!PageHelper.AuthorisePostRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.CreateButton %>" />
								<%
							}
                            else
                            {
                                if (_incidentRepository.GetByID((long)resource.ID.Value).Deleted)
                                {
									%><input id="buttonSave" <% if(!PageHelper.AuthorisePutRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.UndeleteButton %>" /><%
                                }
                                else
                                {
									%>
										<input id="buttonSave" <% if(!PageHelper.AuthorisePutRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.SaveButton %>" />
										<input id="buttonDelete" <% if(!PageHelper.AuthoriseDeleteRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.DeleteButton %>" />
									<%
								}
                            }
                        %>
                        <button id="assigneToMe" type="button"><%= IncidentLabels.AssigneIncidentToMe %></button>
                        <button id="idMoreAction" type="button"><%= IncidentLabels.MoreActionsMenuButton%></button>                        
                        <button id="categoryButtonId" type="button"><%= CommonLabels.Category%>...</button>
                        <span id="backToDesktop"></span>
                    </div>
                </td>
                <td style="text-align: right">
                    <span class="primaryValue"><%= CommonLabels.ID %>:</span>
                    <input id="ID" class="primaryValue" type="text" value="<%= resource.ID %>" readonly="readonly" />
                </td>
            </tr>
        </tbody>
    </table>
    </div>
    <table class="psFormTable" border="0" cellpadding="0" cellspacing="0">
        <colgroup>
            <col class="psColon1" />
            <col />
            <col class="psColMid" />
            <col class="psColon3" />
            <col />
        </colgroup>
        <tbody>
            <tr>
                <td class="psFormCell psLabelRequire">
                    <span><%= CommonLabels.Title%></span>
                </td>
                <td class="psFormCell" >
                    <input id="Title" name="Title" class="psTextbox" type="text" value="<%= resource.Title %>"/>
                </td>
                <td class="psFormMid"></td>
                <td class="psFormCell psLabelRequire">
                    <span><%= IncidentLabels.Service%></span>
                </td>
                <td class="psFormCell">                
                    <select id="Service.ID" class="styled">
                          <option value="0"></option>
                        <%
							foreach (Service item in _incidentServiceRepository.GetOrderedByName())
                            {
                        %>
                            <option value="<%= item.ID %>" <%= HtmlHelper.OptionSelect(null !=  resource.Service.Value && item.ID == resource.Service.Value.ID.Value) %>>
                            <%= item.Name%></option>
                        <%
                            }
                        %>
                    </select>
                </td>
            </tr>
            <tr>
                <td class="psFormCell">
                    <%= IncidentLabels.Contact %>
                </td>
                <td class="psFormCell">
					<div id="contactLookup">
						<table border="0" cellpadding="0" cellspacing="0"  class="acTable" >
							<tr>
							    <td class="lookupbtn">
							       	<span class="lookup pl-lookup-panel-show"></span>
								</td>
								<td class="acbox">
									<div class="pl-autocomplete">
									    <input style="display:none; width:100%" class="psTextbox pl-autocomplete-input yui-ac-input" type="text" />
										<div class="pl-autocomplete-container" ></div>
									</div>
									<a id="contactLink" href="<%= null != resource.Contact.Value ? resource.Contact.Value.URL.Value : string.Empty %>"> <%= null != resource.Contact.Value ? resource.Contact.Value.Name.Value : string.Empty %>  </a>
						           </td>								
							</tr>
						</table>
						<div  class="resizablepanel pl-lookup-panel">
							<div class="bd">
								<div class="yui-skin-sam pl-lookup-datatable"></div>
							</div>
							<div class="ft"></div>
						</div>
					</div>
                </td>
                <td class="psFormMid"></td>
                <td class="psFormCell">
                    <span><%= IncidentLabels.ServiceLevel%></span>
                </td>
                <td class="psFormCell">
                    <a id="_serviceLevelLink" href="<%= null != resource.ServiceLevel.Value ? resource.ServiceLevel.Value.URL.Value : string.Empty %>">
                        <%= null != resource.ServiceLevel.Value ? resource.ServiceLevel.Value.Name.Value : string.Empty%>
                    </a>
                </td>
            </tr>
            <tr>
                <td class="psFormCell">
                    <span><%= IncidentLabels.Account%></span>
                </td>
                <!-- style="border:solid 1px black;" -->
                <td class="psFormCell" >
                    <select id="Account.ID" class="styled">
                        <option value="0"></option>
                        <%
							if (null != resource.Contact && null != resource.Contact.Value.ID.Value && 0 != (long)resource.Contact.Value.ID.Value)
							{
								try
								{
									foreach (BusinessUnit item in _businessUnitRepository.GetAccountByMember((long)resource.Contact.Value.ID.Value))
									{
										%><option value="<%= item.ID %>" <%= HtmlHelper.OptionSelect(null !=  resource.Account.Value && item.ID == resource.Account.Value.ID.Value) %>><%= item.Name%></option><%
									}
								}
								catch
								{
								}
							}
							else
							{
								try
								{
									foreach (BusinessUnit item in _businessUnitRepository.GetAll())
									{
										if (item.BusinessUnitType == BusinessUnitType.Account)
										{
											%><option value="<%= item.ID %>" <%= HtmlHelper.OptionSelect(null !=  resource.Account.Value && item.ID == resource.Account.Value.ID.Value) %>><%= item.Name%></option><%
										}
									}
								}
								catch
								{
								}
							}                          	
                        %>
                    </select>
                </td>
                <td class="psFormMid"></td>
                <td class="psFormCell">
                    <span><%= IncidentLabels.ServiceLevelAgreement%></span>
                </td>
                <td class="psFormCell">
                    <a id="_serviceLevelAgreementLink" href="<%= null != resource.ServiceLevelAgreement.Value ? resource.ServiceLevelAgreement.Value.URL.Value : string.Empty %>">
                        <%= null != resource.ServiceLevelAgreement.Value ? resource.ServiceLevelAgreement.Value.Name.Value : string.Empty%>
                    </a>
                </td>
            </tr>
            <tr>
				<td class="psFormCell">
                    <span><%= IncidentLabels.User%></span>
                </td>
                <td class="psFormCell">
                    <div id="userLookup">
						<table border="0" cellpadding="0" cellspacing="0" class="acTable" >
							<tr >
							    <td class="lookupbtn">
							        <span class="lookup pl-lookup-panel-show"></span>									
								</td>
								<td class="acbox">
									<div class="pl-autocomplete">
									    <input style="display:none" class="psTextbox pl-autocomplete-input" type="text" />
										<div class="pl-autocomplete-container" ></div>
									</div>
									<a id="userLink" href="<%= null != resource.User.Value ? resource.User.Value.URL.Value : string.Empty %>">	<%= null != resource.User.Value ? resource.User.Value.Name.Value : string.Empty %></a>
						           </td>								
							</tr>
						</table>
						<div class="resizablepanel pl-lookup-panel">
							<div class="bd">
								<div class="yui-skin-sam pl-lookup-datatable"></div>
							</div>
							<div class="ft"></div>
						</div>
					</div>
                </td>
                <td class="psFormMid">
                </td>
				<td class="psFormCell">
                    <span><%= IncidentLabels.Origin%></span>
                </td>
                <td class="psFormCell">
                    <select id="Origin.ID" class="styled">
                        <option value="0"></option>
                        <%
							foreach (Origin item in _originRepository.GetOrderedByName())
                            {
                        %><option value="<%= item.ID %>" <%= HtmlHelper.OptionSelect(null != resource.Origin.Value && item.ID == resource.Origin.Value.ID.Value) %>>
                            <%= item.Name%></option>
                        <%
                            }
                        %>
                    </select>
                </td>
            </tr>
            <tr>
                <td class="psFormCell psLabelRequire">
                    <span><%= IncidentLabels.Team%></span>
                </td>
                <td class="psFormCell">
					<div id="teamLookup">
						<table border="0" cellpadding="0" cellspacing="0" class="acTable" >
							<tr >
								<td class="lookupbtn">
								    <span class="lookup pl-lookup-panel-show"></span>
								</td>
								<td class="acbox">
									<div class="pl-autocomplete">
									    <input style="display:none" class="psTextbox pl-autocomplete-input" type="text" />
										<div class="pl-autocomplete-container" ></div>
									</div>
									<a id="teamLink" href="<%= null != resource.Team.Value ? resource.Team.Value.URL.Value : string.Empty %>"> <%= null != resource.Team.Value ? resource.Team.Value.Name.Value : string.Empty%>  </a>
						        </td>
							</tr>
						</table>

						<div class="resizablepanel pl-lookup-panel">
							<div class="bd">
								<div class="yui-skin-sam pl-lookup-datatable"></div>
							</div>
							<div class="ft"></div>
						</div>
					</div>
                </td>
                <td class="psFormMid">
                </td>
               <td class="psFormCell">
                </td>
                <td class="psFormCell">
                </td>
            </tr>
            <tr>
                <td class="psFormCell psLabelRequire">
                    <span><%= IncidentLabels.IncidentStatus %></span>
                </td>
                <td class="psFormCell">
                    <select id="Status.ID" class="styled">
                        <%
                            foreach (Status item in Enum.GetValues(typeof(Status)))
                            {
								%><option value="<%= (long)item %>" <%= HtmlHelper.OptionSelect(null !=  resource.Status.Value && (long)item == resource.Status.Value.ID.Value) %>><%= StatusLabels.GetLabel(item)%></option><%
                            }
                        %>
                    </select>
                </td>
                <td class="psFormMid">
                </td>
                <td class="psFormCell">
                    <span>
                        <%= IncidentLabels.ClosureClassification%></span>
                </td>
                <td class="psFormCell">
                    <select id="ClosureClassification.ID" class="styled">
                        <option value="0"></option>
                        <%
							foreach (ClosureClassification item in _closureClassificationRepository.GetOrderedByName())
                            {
                        %><option value="<%= item.ID %>" <%= HtmlHelper.OptionSelect(null != resource.ClosureClassification.Value && item.ID == resource.ClosureClassification.Value.ID.Value) %>>
                            <%= item.Name%></option>
                        <%
                            }
                        %>
                    </select>
                </td>
            </tr>
            <tr>
				<td class="psFormCell psLabelRequire">
                    <span>
                        <%= IncidentLabels.IncidentPriority%></span>
                </td>
                <td class="psFormCell">
                    <select id="Priority.ID" class="styled">
                        <%
                            foreach (Priority item in Enum.GetValues((typeof(Priority))))
                            {
                        %><option <%= HtmlHelper.OptionSelect((long)item == resource.Priority.Value.ID.Value) %>
                            value="<%= (long)item %>">
                            <%= PriorityLabels.GetLabel(item)%></option>
                        <%
                            }
                        %>
                    </select>
                </td>                
                <td class="psFormMid">
                </td>
                 <td class="psFormCell">
                    <span><%= CommonLabels.Attachments%></span>
                </td>
                <td class="psFormCell">
                    <div id="attachmentStrip"></div>
                    <span id="uploadFailed"  style="visibility: hidden"><%= CommonLabels.UploadFailedMessage%></span>
                </td>
            </tr>
            <tr class="noteControl" style="display:none">
			    <td class="psFormCell psBarNoBorder" colspan="5"><span><%= CommonLabels.Note %></span> <a href="" id="noteShowHide"><%= CommonLabels.Hide %></a></td>
            </tr>
            <tr class="noteControl" style="display:none">
                <td id="noteTextArea" class="psFormCell" colspan="5">
                    <textarea class="psTextarea expand25-350 resizable" id="<%= resource.Note.Name %>"><%= resource.Note.Value%></textarea>
                </td>
            </tr>
            <tr class="workOrderControl" style="display:none">
                <td class="psFormCell psBar" colspan="5"><span> <%= IncidentLabels.WorkOrders %> </span></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr class="workOrderControl" style="display:none" >
                <td  class="psFormCell" >
                    <%= IncidentLabels.AddWorkOrder %>
                </td>
                <td class="psFormCell workOrderControl" colspan="4" style="display:none">
                    <div id="workOrderLookup">
						<table border="0" cellpadding="0" cellspacing="0" >
							<tr >
								<td class="acbox">
									<div class="pl-autocomplete">
									    <input class="psTextbox pl-autocomplete-input" type="text" />
										<div class="pl-autocomplete-container" ></div>
									</div>
						           </td>
								<td class="lookupbtn">
									<button class="lookup pl-lookup-panel-show"></button>
								</td>
							</tr>
						</table>
						<div class="resizablepanel pl-lookup-panel">
							<div class="bd">
								<div class="yui-skin-sam pl-lookup-datatable"></div>
							</div>
							<div class="ft"></div>
						</div>
					</div>
                </td>
            </tr>

            <tr class="workOrderControl" style="display:none">
                <td class="psFormCell" colspan="5">
                    <div id="WorkOrders" class="yui-skin-sam">
                    </div>
                </td>
            </tr>
            <tr>
                <td class="psFormCell psBarNoBorder" colspan="5">
                    <span><%= IncidentLabels.IncidentDescription%></span>
                </td>
            </tr>            
            <tr>
                <td class="psFormCell" colspan="5">
                    <textarea class="psTextarea expand25-350 resizable" id="<%= resource.Description.Name %>"><%= resource.Description %></textarea>
                </td>
            </tr>
            <tr>
                <td class="psFormCell psBarNoBorder" colspan="5">
                    <span><%= IncidentLabels.IncidentResolution%></span>
                </td>
            </tr>
            <tr>
                <td class="psFormCell" colspan="5">
                    <textarea  class="psTextarea expand25-350 resizable" id="<%= resource.Resolution.Name %>"><%= resource.Resolution %></textarea>
                </td>
            </tr>
            <tr>
                <td class="psFormCell psBarNoBorder" colspan="5">
                    <span><%= CommonLabels.ConversationHistory%></span>
                </td>
            </tr>
            <tr>
                <td class="psFormCell" colspan="5">
                    <div id="conversation">
						<div class="ps-conversation-rows">
							<div class="ps-conversation-template" style="visibility: hidden;">
							    <div class="conversation-head">
							    <!-- <%= CommonLabels.PostedBy %> --> <a class="ps-conversation-postedby-urn"><span class="ps-conversation-postedby-name"></span></a>
										 - ( <span class="ps-conversation-postedon convpostedon"></span> )
							    </div>
							    <div class="con-gr1" ></div>					   
							    
								<table class="conversation-body" style="width: 100%;" cellpadding="0" cellspacing="0">
									<!-- <tr class="">
										<td class="contd"><%= CommonLabels.PostedBy %> <a class="ps-conversation-postedby-urn"><span class="ps-conversation-postedby-name"></span></a></td>
										<td class="contd convpostedon"><span class="ps-conversation-postedon"></span></td>
									</tr> --> 
									<tr>
										<td colspan="2" class="ps-conversation-attachments-container">
										    <div class="con-sub"><span class="con-subhead"><%= CommonLabels.Attachments %>:</span></div>
											<span class="ps-conversation-attachments"></span>											
										</td>
									</tr>
									<tr>
										<td colspan="2" class="ps-conversation-description-container">
											<div class="con-sub"><span class="con-subhead"><%= CommonLabels.Description %> </span></div>
											<span class="ps-conversation-description"></span>											
										</td>
									</tr>
									<tr>
										<td colspan="2" class="ps-conversation-resolution-container">
										    <div class="con-sub"><span class="con-subhead"><%= CommonLabels.Resolution %></span></div>
											<span class="ps-conversation-resolution"></span>											
										</td>
									</tr>
								</table>
								<!-- <div class="convfooter"></div> --> 
							</div>
						</div>
					</div>
                </td>
            </tr>
        </tbody>
    </table>
    </div>

    <polar:Footer ID="Footer1" runat="server" />
    <script type="text/javascript">
		var resource = <%= _jsonResRep %>;        
        var categoriesAll = [];
        <%
            foreach (Category item in _categoryRepository.GetOrderedByName())
            {
				%>categoriesAll.push({ID:"<%= item.ID %>", Name:"<%= item.Name %>"});<%
            }
        %>
    </script>

    <polar:Includes runat="server" />

    <script type="text/javascript">
        $(document).ready(function() {
            POLAR.View.CheckForExtraInfo();
            POLAR.View.Page();
        });

        var incidentConversation;
        POLAR.View.Page = function() {
            POLAR.View.setTitleAndResourceName(resource.LabelsCommon.Incident);
            POLAR.View.CategoryButton(resource.Categories, categoriesAll, "categoryButtonId");

            if ($('#assigneToMe').length) {
                var oAssigneToMe = new YAHOO.widget.Button("assigneToMe");
                oAssigneToMe.on("click", function() {
                    autoCompleteLookupUser._changeOnLinkedControl(AuthenticatedPerson.ID);
                    $("#Resolution").focus();
                    if ($("#Resolution").height() < 200) {
                        $("#Resolution").height("200px");
                    }
                });
            }

            //Show Note if exist
            if (($('#Note').val().length) > 0) {
                $(".noteControl").show();
            }
            else {
            }

            //Show Work Orders if exist
            if (!YAHOO.lang.isUndefined(resource.WorkOrders) && !YAHOO.lang.isNull(resource.WorkOrders) && YAHOO.lang.isObject(resource.WorkOrders)) {
                if (resource.WorkOrders.length > 0) {
                    POLAR.View.Page.CreateAutoCompleteLookupWorkOrder();
                    $(".workOrderControl").show();
                }
            }
            else {
                $(".workOrderControl").hide();
            }

            $('#noteShowHide').click(function(event) {
                event.preventDefault();
                event.stopPropagation();
                if ($("#noteTextArea").is(':visible')) {
                    $("#noteShowHide").text(" <%= CommonLabels.Show%>");
                    $('#noteTextArea').hide();
                }
                else {
                    $("#noteShowHide").text(" <%= CommonLabels.Hide%>");
                    $('#noteTextArea').show();
                }
            });

            MoreActionMenu = function() {
                //Show Work Orders if hiden and if exist any work order included in this incident
                var moreActions = new Array();
                moreActions[0] = '<%= IncidentLabels.AddWorkOrderMenuItem%>';
                moreActions[1] = '<%= IncidentLabels.ViewIncidentHistoryMenuItem%>';
                moreActions[2] = '<%= CommonLabels.AddNote%>';
                var aItemData = [
                        { text: moreActions[0] },
                        { text: moreActions[1], url: resource.HistoryURL },
                        { text: moreActions[2] }
                ];

                var oMenu = new YAHOO.widget.Menu("basicmenu", { position: "dynamic" });
                oMenu.addItems(aItemData);

                // Define a handler for the "click" event
                function onClick(p_sType, p_aArgs) {
                    oMenuItem = p_aArgs[1];
                    if (oMenuItem.index == 0) {
                        if (YAHOO.lang.isUndefined(POLAR.View.Page.autoCompleteLookupWorkOrderCreated)) {
                            POLAR.View.Page.CreateAutoCompleteLookupWorkOrder();
                        }
                        $(".workOrderControl").show();
                        $("#workOrderLookup input").focus();
                    }

                    if (oMenuItem.index == 2) {
                        $(".noteControl").show();
                        $("#Note").focus();
                        $("#Note").height("200px");
                    }
                }
                var oMenuToggleButton = new YAHOO.widget.Button("idMoreAction", { type: "menu", menu: oMenu.getItems() });
                oMenuToggleButton.getMenu().subscribe("click", onClick);
            }

            MoreActionMenu();
            YAHOO.util.Event.addListener(YAHOO.util.Dom.get('Account.ID'), 'change', POLAR.View.Page.changeAccount);
            YAHOO.util.Event.addListener(YAHOO.util.Dom.get('Service.ID'), 'change', POLAR.View.Page.changeService);

            POLAR.View.AttachmentStrip(resource.Attachments, '<%= CommonLabels.Upload %>', '<%= CommonLabels.Delete %>', YAHOO.util.Dom.get('attachmentStrip'), '<%= UrlHelper.GetUrl("/api/attachment") %>');
            POLAR.View.Events.addOnResourceSavedEvent(POLAR.View.Page.onOperationSuccessful);

            incidentConversation = new POLAR.View.Conversation(YAHOO.util.Dom.get('conversation'), resource.Conversation);

            autoCompleteLookupContact = new POLAR.Widget.AutoCompleteLookup({
                id: 'contactLookup',
                url: '<%= UrlHelper.GetUrl("/api/contacts") %>',
                urlItem: '<%= UrlHelper.GetUrl("/api/contact/") %>',
                linkID: "contactLink",
                propertyName: "Contact",
                resourceHolder: resource,
                autoCompleteData: { schema: ['ID', 'UserName', 'Name', 'Email'], query: '?maxresults=60&textsearch={0}*' },
                lookupPanelData: {
                    fields: [{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber }, 'UserName', 'Name', 'Email', 'URL'],
                    columnDefinitions: [
                        { key: 'Add', formatter: 'customContact' },
	                    { key: 'ID', label: '<%= CommonLabels.ID %>', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
	                    { key: 'UserName', label: '<%= CommonLabels.Username %>', sortable: true, resizeable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl },
                        { key: 'Name', label: '<%= CommonLabels.Name %>', sortable: true, resizeable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl },
                        { key: 'Email', label: '<%= CommonLabels.Email %>', sortable: true, resizeable: true }
                    ]
                },
                customChangeLinkedControl: POLAR.Widget.AutoCompleteLookup.changeContact
            });

            autoCompleteLookupUser = new POLAR.Widget.AutoCompleteLookup({
                id: 'userLookup',
                url: '<%= UrlHelper.GetUrl("/api/users") %>?team=0',
                urlItem: '<%= UrlHelper.GetUrl("/api/user/") %>',
                linkID: "userLink",
                propertyName: "User",
                resourceHolder: resource,
                autoCompleteData: { schema: ['ID', 'UserName', 'Name', 'Email'], query: '&maxresults=60&textsearch={0}*' },
                lookupPanelData: {
                    fields: [{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber }, 'UserName', 'Name', 'Email', 'URL'],
                    columnDefinitions: [
                        { key: 'Add', formatter: 'customContact' },
	                    { key: 'ID', label: '<%= CommonLabels.ID %>', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
	                    { key: 'UserName', label: '<%= CommonLabels.Username %>', sortable: true, resizeable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl },
                        { key: 'Name', label: '<%= CommonLabels.Name %>', sortable: true, resizeable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl },
                        { key: 'Email', label: '<%= CommonLabels.Email %>', sortable: true, resizeable: true }
                    ]
                }
            });

            autoCompleteLookupTeam = new POLAR.Widget.AutoCompleteLookup({
                id: 'teamLookup',
                url: '<%= UrlHelper.GetUrl("/api/teams") %>?assignableteam=true',
                urlItem: '<%= UrlHelper.GetUrl("/api/team/") %>',
                customChangeLinkedControl: function(itemResource) {
                    if (itemResource) {
                        autoCompleteLookupUser.setNewUrl('<%= UrlHelper.GetUrl("/api/users") %>' + "?team=" + itemResource.ID);
                    } else {
                        autoCompleteLookupUser.setNewUrl('<%= UrlHelper.GetUrl("/api/users") %>' + "?team=0");
                    }
                },
                linkID: "teamLink",
                propertyName: "Team",
                resourceHolder: resource,
                autoCompleteData: { schema: ['ID', 'Name', 'Email'], query: '&maxresults=60&textsearch={0}*' },
                lookupPanelData: {
                    fields: [{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber }, 'Name', "Email", 'URL'],
                    columnDefinitions: [
                        { key: 'Add', formatter: 'customContact' },
	                    { key: 'ID', label: '<%= CommonLabels.ID %>', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
                        { key: 'Name', label: '<%= CommonLabels.Name %>', sortable: true, resizeable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl },
                        { key: 'Email', label: '<%= CommonLabels.Email %>', sortable: true, resizeable: true }
                    ]
                }
            });

            //initi back to incidents desktops
            var flag = POLAR.Util.Find(POLAR.Util.GetPermissioneForUrnFinder, UserResourcePermissions.ResorucePermissions, "incidents");
            if (flag == true) {
                var uriDesktop = BASE_URL + "incidents?maxresults=100";
                $("#backToDesktop").append("<a href='" + uriDesktop + "'>" +  "&lt;&lt; " + resource.LabelsCommon.Incidents + "</a>")
            }
            else { }
        }

        POLAR.View.Page.CreateAutoCompleteLookupWorkOrder = function() {
            autoCompleteLookupWorkOrder = new POLAR.Widget.AutoCompleteLookup({
                id: 'workOrderLookup',
                url: '<%= UrlHelper.GetUrl("/api/workorders") %>?attachedtoincident=0',
                urlItem: '<%= UrlHelper.GetUrl("/api/workorder/") %>',
                propertyName: "WorkOrder",
                resourceHolder: resource,
                autoCompleteData: { schema: ['ID', 'Title'], query: '&maxresults=60&textsearch={0}*' },
                lookupPanelData: {
                    fields: [{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber }, 'Title', 'URL'],
                    columnDefinitions: [
                            { key: 'Add', formatter: 'customContact' },
                            { key: 'ID', label: '<%= CommonLabels.ID %>', sortable: true, sortOptions: { defaultOrder: 'desc'} },
                            { key: 'Title', label: '<%= CommonLabels.Title %>', sortable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl }
                        ]
                },
                dataTableData: {
                    resourceName: "WorkOrders",
                    fields: [
						{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber }, 
						'Title', 
						'URL', 
						{ key: 'ModifiedOn', parser: POLAR.View.DateTime.stringToDate },
						'Deadline',
						'Contact.Name',
						'Contact.URL',
						'User.Name',
						'User.URL',
						'Team.Name',
						'Team.URL',
						'Account.Name',
						'Account.URL',
						'Status.Name',
						'Priority.Name'
		            ], columnDefinitions: [
				            { key: '' },
				            { key: 'ID', label: '<%= CommonLabels.ID %>', sortable: true, resizeable: true, sortOptions: { defaultOrder: 'desc'} },
				            { key: 'Title', label: '<%= CommonLabels.Title %>', sortable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl },
							{ key: 'Deadline', label: '<%= CommonLabels.Deadline %>', sortable: true, sortOptions: { defaultDir: YAHOO.widget.DataTable.CLASS_DESC }, formatter: POLAR.View.DataTable.formatDate },
				            { key: 'Contact.Name', label: '<%= CommonLabels.Contact %>', sortable: true, resizeable: true, formatter: POLAR.View.DataTable.formatServiceUser },
							{ key: 'User.Name', label: '<%= CommonLabels.User %>', sortable: true, resizeable: true, formatter: POLAR.View.DataTable.formatAssignee },
							{ key: 'Team.Name', label: '<%= CommonLabels.Team %>', sortable: true, resizeable: true, formatter: POLAR.View.DataTable.formatTeam },
							{ key: 'Account.Name', label: '<%= CommonLabels.Account %>', sortable: true, resizeable: true, formatter: POLAR.View.DataTable.formatAccount },			    
							{ key: 'Status.Name', label: '<%= CommonLabels.Status %>', sortable: true, resizeable: true },
							{ key: 'Priority.Name', label: '<%= CommonLabels.Priority %>', sortable: true, resizeable: true },
	           			    { key: 'ModifiedOn', label: '<%= CommonLabels.ModifiedOn %>', sortable: true, sortOptions: { defaultDir: YAHOO.widget.DataTable.CLASS_DESC }, formatter: POLAR.View.DataTable.formatDate }	            
				        ]
                }
            });
            
            this.autoCompleteLookupWorkOrderCreated = true;
        }

        POLAR.View.Page.onOperationSuccessful = function() {
			if(resource.ID != 0) {
        		var descriptionElement = YAHOO.util.Dom.get('Description');
        		var resolutionElement = YAHOO.util.Dom.get('Resolution');

        		incidentConversation.addRow({
        			Description: resource.Description.replace(/</g, '&lt;'),
        			Resolution: resource.Resolution.replace(/</g, '&lt;'),
        			Attachments: resource.Attachments,
        			PostedOn: new Date(),
        			PostedBy: AuthenticatedPerson
        		}, true);
        		
        		descriptionElement.value = '';
        		resolutionElement.value = '';
				
        		resource.Attachments.length = 0;
			}
        }

        POLAR.View.Page.changeService = function() {
            var serviceIDElement = YAHOO.util.Dom.get('Service.ID');
            var serviceID = serviceIDElement.value;
            var url = '';
            if (serviceID == "0") {
                url = '<%= UrlHelper.GetUrl("/api/service") %>';
            }
            else {
                url = '<%= UrlHelper.GetUrl("/api/service/") %>' + serviceID;
            }

            POLAR.View.asyncGet(url, function(service) {
                POLAR.View.Page.updateServiceLevelManagementFields();
            });
        }

        POLAR.View.Page.changeAccount = function() {
            var accountElement = YAHOO.util.Dom.get('Account.ID');
            if (accountElement.value != "0") {
                var url = '<%= UrlHelper.GetUrl("/api/account/") %>' + accountElement.value;

                POLAR.View.asyncGet(url, function(account) {
                    resource.Account = account;
                    POLAR.View.Page.updateServiceLevelManagementFields();
                });
            } else {
                resource.Account = null;
                POLAR.View.Page.updateServiceLevelManagementFields();
            }
        }

        POLAR.View.Page.updateServiceLevelManagementFields = function() {
            var serviceIDElement = YAHOO.util.Dom.get('Service.ID');
            var serviceID = serviceIDElement.value;
            if (null != resource.Account && 0 != resource.Account.ID && 0 != serviceID) {
                POLAR.View.Page.setServiceLevelManagementFields();
                var url = '<%= UrlHelper.GetUrl("/api/servicelevelagreements?account.id=") %>' + resource.Account.ID;

                POLAR.View.asyncGet(url, function(serviceLevelAgreements) {
                    for (var n = 0; n < serviceLevelAgreements.Items.length; n++) {
                        var sla = serviceLevelAgreements.Items[n];
                        if (sla.Service.ID == serviceID) {
                            POLAR.View.Page.setServiceLevelManagementFields(sla);
                        }
                    }
                });
            }
            else {
                POLAR.View.Page.setServiceLevelManagementFields();
            }
        }

        POLAR.View.Page.setServiceLevelManagementFields = function(sla) {
            var serviceLevelLinkElement = YAHOO.util.Dom.get('_serviceLevelLink');
            var serviceLevelAgreementLinkElement = YAHOO.util.Dom.get('_serviceLevelAgreementLink');

            if (!YAHOO.lang.isUndefined(sla)) {
                serviceLevelLinkElement.href = sla.ServiceLevel.URL;
                serviceLevelLinkElement.innerHTML = sla.ServiceLevel.Name;

                serviceLevelAgreementLinkElement.href = sla.URL;
                serviceLevelAgreementLinkElement.innerHTML = sla.Name;
            }
            else {
                serviceLevelLinkElement.href = '';
                serviceLevelLinkElement.innerHTML = '';

                serviceLevelAgreementLinkElement.href = '';
                serviceLevelAgreementLinkElement.innerHTML = '';
            }
        }
    </script>
	<script type="text/javascript">
	    $(function() {
	        $('#pppost').click(function(event) {
	        });

	    })
	</script>
    <script runat="server">
        IncidentResource resource = null;
        string _jsonResRep;

        BusinessUnitRepository _businessUnitRepository;
        IncidentRepository _incidentRepository;
        ClosureClassificationRepository _closureClassificationRepository;
        OriginRepository _originRepository;
        readonly CategoryRepository _categoryRepository = IoC.Container.Resolve<CategoryRepository>();
        ServiceRepository _incidentServiceRepository;
        protected void Page_Load(object sender, EventArgs e)
        {
			try
			{
				PageHelper.RedirectToInstallationIfNoDatabaseFound();
				_businessUnitRepository = IoC.Container.Resolve<BusinessUnitRepository>();
				_incidentRepository = IoC.Container.Resolve<IncidentRepository>();
				_closureClassificationRepository = IoC.Container.Resolve<ClosureClassificationRepository>();
				_originRepository = IoC.Container.Resolve<OriginRepository>();
				_incidentServiceRepository = IoC.Container.Resolve<ServiceRepository>();

				ApiHttpHandler apiHttpHandler = new ApiHttpHandler();
				ResourceHandlerResult resourceHandlerResult = apiHttpHandler.ProcessPageRequest(Context);
				_jsonResRep = resourceHandlerResult.JsonResourceRepresentation;
				resource = resourceHandlerResult.EntityResoruceRepresentation as IncidentResource;
			}
			catch (Exception ex)
			{
				Response.Write("ERROR: " + ex.Message);
				Response.End();
			}
        }
    </script>
</body>
</html>
