<%@ Page Language="C#" %>
<%@ Import namespace="System.Runtime.InteropServices"%>
<%@ Import namespace="Polar.ServiceDesk.WebUserInterface.Infrastructure.ResourceHandlers"%>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" >
<head>
    <title><%= IncidentLabels.IncidentsTitle %></title>
    <polar:CssIncludes runat="server"/>
</head>
<body class="yui-skin-sam">
    <polar:Navigation runat="server" />

    <div id="resourceForm" <% if(HttpContext.Current.Response.StatusCode != 200){%> style="display: none" <% } %> >
        <div id="filter">
		<input id="textsearch" class="ps-filter-textsearch textboxMiddle" type="text" />		
		<input id="buttonGo" class="ps-filter-gobutton" type="button" value="<%= CommonLabels.Search %>" />						
		<span><%= IncidentLabels.IncidentStatus %></span>
		<select id="Status.ID" class="styled middlewidth" >
			<option value=""></option>
			<%
                foreach (Status item in Enum.GetValues(typeof(Status)))
				{
					%><option value="<%=(long)item%>"><%=StatusLabels.GetLabel(item)%></option><%
				}
			%>
		</select>

		<span><%= CommonLabels.MaximumResults %></span>
		<select id="maxResults" class="styled smallwidth">
            <option value="0"></option>
            <option value="10" <%= HtmlHelper.OptionSelect(Request.RawUrl.Contains("maxresults") && Request.QueryString[0] == "10") %>>10</option>
			<option value="50" <%= HtmlHelper.OptionSelect(Request.RawUrl.Contains("maxresults") && Request.QueryString[0] == "50") %>>50</option>
			<option value="100" <%= HtmlHelper.OptionSelect(Request.RawUrl.Contains("maxresults") && Request.QueryString[0] == "100") %>>100</option>
			<option value="200" <%= HtmlHelper.OptionSelect(Request.RawUrl.Contains("maxresults") && Request.QueryString[0] == "200") %>>200</option>
			<option value="500" <%= HtmlHelper.OptionSelect(Request.RawUrl.Contains("maxresults") && Request.QueryString[0] == "500") %>>500</option>
			<option value="1000" <%= HtmlHelper.OptionSelect(Request.RawUrl.Contains("maxresults") && Request.QueryString[0] == "1000") %>>1000</option>
	    </select>

	    

	</div>

    <br />

    <div id="dataTableContainer" class="yui-skin-sam"></div>
    </div>

    <polar:Footer runat="server" />
    <script type="text/javascript">
        var resource = <%= _jsonResRep %>
    </script>
    <polar:Includes runat="server" />

    <script type="text/javascript">
        var dataTable;  //MUST be outside of function for proper working of selectOrUnselectAllCheckboxes function        
        YAHOO.util.Event.onDOMReady(function() {
            POLAR.View.CheckForExtraInfo();
            POLAR.View.Page();
        });

        POLAR.View.Page = function() {
            POLAR.View.setTitleAndResourceName(resource.LabelsCommon.Incidents);
            POLAR.View.Page.initializeGrid();

            var filter = new POLAR.View.Filter(YAHOO.util.Dom.get('filter'), {
                viewUrl: '<%= UrlHelper.GetUrl("/api/filter") %>',
                args: [
                    { id: 'maxResults', urlValueName: 'maxresults', type: 'select' },
                    { id: 'textsearch', urlValueName: 'textsearch', type: 'textbox' },                    
		            { urlValueName: 'status' }
                ],
                onGetArguments: function(args) {
                    var valStatus = $(POLAR.Util.jqIdFormat("Status.ID")).selectedOptions();
                    if (valStatus[0].value != 0) {
                        args['status'] = valStatus[0].value;
                    }
                },
                onSetArguments: function(args) {
                    var statusID = args['status'];
                    $(POLAR.Util.jqIdFormat("Status.ID")).selectOptions("" + statusID);
                }
            });
        };

        POLAR.View.Page.initializeGrid = function() {
            var dataSource = POLAR.View.DataTable.createDataSource(resource);
			dataSource.responseSchema = {
			    resultsList: 'Items',
			    fields: [
			        { key: '<%= IncidentContactResource.Meta.ID.Name %>', parser: YAHOO.util.DataSource.parseNumber },
			        '<%= IncidentContactResource.Meta.Title.Name %>',
			        '<%= IncidentContactResource.Meta.URL.Name %>',
			        'Contact.Name',
			        'Status.Name',
			        { key: 'ModifiedOn', parser: POLAR.View.DateTime.stringToDate }
			        ]
			};

			var dataTableContainerWidth = $("#dataTableContainer").width(); 
			dataTable = new YAHOO.widget.DataTable('dataTableContainer', [
				{ label: '<input class="selectall" type="checkbox" onclick="POLAR.View.DataTable.selectOrUnselectAllCheckboxes(this, dataTable)" />', formatter: YAHOO.widget.DataTable.formatCheckbox, resizeable: true },
				{ key: 'ID', label: '<%= CommonLabels.ID %>', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
				{ key: 'Title', label: '<%= CommonLabels.Title %>', maxAutoWidth: dataTableContainerWidth / 3, sortable: true, resizeable: true, formatter: POLAR.View.DataTable.formatUrl },
				
				<% if(showContact) { %>
				{ key: 'Contact.Name', label: '<%= IncidentLabels.Contact %>', sortable: true, resizeable: true },
				<% } %>
				
				{ key: 'Status.Name', label: '<%= IncidentLabels.IncidentStatus %>', sortable: true, resizeable: true },
				{ key: 'ModifiedOn', label: '<%= CommonLabels.ModifiedOn %>', maxAutoWidth: dataTableContainerWidth / 7, sortable: true, sortOptions: { defaultDir: YAHOO.widget.DataTable.CLASS_DESC }, formatter: POLAR.View.DataTable.formatDate }
			], dataSource, {
				sortedBy: { key: 'ModifiedOn', dir: YAHOO.widget.DataTable.CLASS_DESC },				
        		draggableColumns: true,
        		paginator: POLAR.View.DataTable.createDefaultPaginator()
			});

			POLAR.View.DataTable.configDataTable(dataTable);

			POLAR.View.DataTable.configDeleteUndelete({
				dataTable: dataTable,
				dataTableItems: resource.Items,
				dataTableDeleteButton: YAHOO.util.Dom.get('deleteButton'),
				dataTableUndeleteButton: YAHOO.util.Dom.get('undeleteButton')
			});

			//POLAR.View.createMenuOnTable(dataTable, 'dataTableContainer');
			//set with on first and second colon for beter visula efect
			$("#dataTableContainer table colgroup col:lt(2)").css('width', '10px');

			var controlAndQueryItems = { "entities": [
                    { "id": "_textsearch", "queryVariable": "textsearch", "control": "textbox" },
		            { "id": "_status", "queryVariable": "status", "control": "select" }
                ]
			};

			YAHOO.util.Event.addListener(YAHOO.util.Dom.get('_gobutton'), 'click', function() { POLAR.View.CreateUrlAndCallUrl(controlAndQueryItems); });
			POLAR.View.OnLoadFillControlFromUrlQuery(controlAndQueryItems);
		};
    </script>

    <script runat="server">
        string _jsonResRep;
		bool showContact = false;

        protected void Page_Load(object sender, EventArgs e)
        {
            PageHelper.RedirectToInstallationIfNoDatabaseFound();

            ApiHttpHandler apiHttpHandler = new ApiHttpHandler();
            ResourceHandlerResult responsePageRequest = apiHttpHandler.ProcessPageRequest(Context);
            _jsonResRep = responsePageRequest.JsonResourceRepresentation;

			IdentityContext ic = IoC.Container.Resolve<IdentityContext>();
			foreach(BusinessUnit bu in ic.AuthenticatedUser.Data.BusinessUnits)
			{
				if (bu.BusinessUnitType == BusinessUnitType.Account)
				{
					if (AuthorisationHelper.GetAuthorizationOnUri("incidentcontacts/account/" + bu.ID))
					{
						showContact = true;
						break;
					}
				}
			}
        }
    </script>
</body>
</html>
