<%@ Page Language="C#" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" >
<head>
    <title><%= ReportLabels.ReportEditHistories%></title>
    <polar:CssIncludes runat="server"/>
</head>

<body class="yui-skin-sam">
    <polar:Navigation runat="server" />

    <div id="resourceForm" <% if(HttpContext.Current.Response.StatusCode != 200){%> style="display: none" <% } %> >
    <div id="dataTableContainer" class="yui-skin-sam"></div>
    </div>

    <script type="text/javascript">
        var resource = <%= _jsonResRep %>
    </script>

    <polar:Footer runat="server" />
	<polar:Includes runat="server" />

	<script type="text/javascript">
	    var dataTable;  //MUST be outside of function for proper working of selectOrUnselectAllCheckboxes function
	    YAHOO.util.Event.onDOMReady(function() {
	        POLAR.View.Initialization();
		    POLAR.View.CheckForExtraInfo();
		    POLAR.View.Page();
		});

		POLAR.View.Page = function() {
		    POLAR.View.setTitleAndResourceName(resource.LabelsCommon.ReportEditHistories);
		    var evalResourceRep = POLAR.View.evalDataInResourceRepresentation(resource);
		    var dataSource = POLAR.View.DataTable.createDataSource(evalResourceRep);
		    //var dataSource = new YAHOO.util.DataSource(evalResourceRep);  //var dataSource = new YAHOO.util.DataSource(resource);
		    //dataSource.responseType = YAHOO.util.DataSource.TYPE_JSON;

		    var item = evalResourceRep.Items[0];
		    POLAR.View.SetPropertyNameToObject(item);

		    var myParseNumber = function(oData) {
		        var jsonStr = YAHOO.lang.JSON.stringify(oData);
		        var number = jsonStr.length * 1; //Convert to number
		        return number;
		    };

		    dataSource.responseSchema = {
		        resultsList: 'Items',
		        fields: [
		            { key: item.GetPropertyName("ID"), parser: YAHOO.util.DataSource.parseNumber },
		            { key: item.GetPropertyName("Data.Title"), parser: POLAR.View.titleParser },
			        item.GetPropertyName("URL"),
			        item.GetPropertyName("CreatedBy.Name"),
			        item.GetPropertyName("CreatedBy.URL"),
			        { key: item.GetPropertyName("Data"), parser: myParseNumber },
			        { key: item.GetPropertyName("CreatedOn"), parser: POLAR.View.DateTime.stringToDate }
			        ]
		    };

		    var formatUser = function(elCell, oRecord, oColumn, sData) {
		        if (sData == null) return;
		        elCell.innerHTML = '<a href=' + oRecord.getData(item.GetPropertyName('CreatedBy.URL')) + '>' + sData + '</a>';
		    };

		    dataTable = new YAHOO.widget.DataTable(
		        'dataTableContainer',
		        [
				    { key: item.GetPropertyName("ID"), label: resource.LabelsCommon.ID, sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
				    { key: item.GetPropertyName("Data.Title"), label: resource.Labels.Title, sortable: true, resizeable: true, formatter: POLAR.View.DataTable.formatUrl },
				    { key: item.GetPropertyName("CreatedBy.Name"), label: resource.LabelsCommon.User, sortable: true, resizeable: true, formatter: formatUser },
				    { key: item.GetPropertyName("Data"), label: resource.Labels.DataSize, sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
				    { key: item.GetPropertyName("CreatedOn"), label: resource.LabelsCommon.Created, sortable: true, resizeable: true, formatter: POLAR.View.DataTable.formatDate }
			    ],
			    dataSource, {
			    sortedBy: { key: item.GetPropertyName("CreatedOn"), dir: YAHOO.widget.DataTable.CLASS_DESC },
			    draggableColumns: true,
			    paginator: POLAR.View.DataTable.createDefaultPaginator()
			});

		    POLAR.View.DataTable.configDataTable(dataTable);
		    //POLAR.View.createMenuOnTable(dataTable, 'dataTableContainer');
		    //set with on first and second colon for beter visula efect
		    $("#dataTableContainer table colgroup col:lt(2)").css('width', '10px');

		    var controlAndQueryItems = { "entities": [
                    { "id": "_textsearch", "queryVariable": "textsearch", "control": "textbox" }
                ]
		    };

		    YAHOO.util.Event.addListener(YAHOO.util.Dom.get('_gobutton'), 'click', function() { POLAR.View.CreateUrlAndCallUrl(controlAndQueryItems); });
		    POLAR.View.OnLoadFillControlFromUrlQuery(controlAndQueryItems);

		};
	</script>

	<script runat="server">
        string _jsonResRep;

	    protected void Page_Load(object sender, EventArgs e)
        {
            PageHelper.RedirectToInstallationIfNoDatabaseFound();

            ApiHttpHandler apiHttpHandler = new ApiHttpHandler();
            ResourceHandlerResult responsePageRequest = apiHttpHandler.ProcessPageRequest(Context);
            _jsonResRep = responsePageRequest.JsonResourceRepresentation;
        }
    </script>
</body>
</html>