<%@ Page Language="C#" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <title><%= ReportLabels.ReportEdits%></title>
    <polar:CssIncludes runat="server" />
</head>
<body class="yui-skin-sam">
    <polar:Navigation ID="Navigation1" runat="server" />
    <div id="resourceForm" <% if(HttpContext.Current.Response.StatusCode != 200){%> style="display: none" <% } %> >
        <div class="desktopTable">
			<div class="desktopTableActions">
			</div>        
			<div id="dataTableContainer" class="yui-skin-sam"></div>
		</div>
    </div>
    <polar:Footer ID="Footer1" runat="server" />
    <script type="text/javascript">
        var resource = <%= _jsonResRep %>;
    </script>
    <polar:Includes ID="Includes1" runat="server" />

    <script type="text/javascript">
        var dataTable; 
        
        $(document).ready(function() {
            POLAR.View.CheckForExtraInfo();
            POLAR.View.Page();
        });

        POLAR.View.Page = function() {
            POLAR.View.setTitleAndResourceName(resource.LabelsCommon.ReportEdits);
            var evalResourceRep = POLAR.View.evalDataInResourceRepresentation(resource);
            var dataSource = POLAR.View.DataTable.createDataSource(evalResourceRep);

            dataSource.responseSchema = {
                resultsList: 'Items',
                fields: [                    
                    { key: "Data.Title", parser: POLAR.View.titleParser }, 
                    "URL",
                    "URI",
        		    { key: "CreatedOn", parser: POLAR.View.DateTime.stringToDate }
        		]
            };

            dataTable = new YAHOO.widget.DataTable('dataTableContainer', [
				    { label: '<input class="selectall" type="checkbox" onclick="POLAR.View.DataTable.selectOrUnselectAllCheckboxes(this, dataTable)" />', formatter: YAHOO.widget.DataTable.formatCheckbox, resizeable: true },				    
				    { key: 'Data.Title', label: resource.Labels.Title, sortable: true, resizeable: true, formatter: POLAR.View.DataTable.formatUrl },
				    { key: "CreatedOn", label: resource.LabelsCommon.Created, sortable: true, sortOptions: { defaultDir: YAHOO.widget.DataTable.CLASS_DESC }, formatter: POLAR.View.DataTable.formatDate }
			    ],
			    dataSource,
			    {
			        sortedBy: { key: "CreatedOn", dir: YAHOO.widget.DataTable.CLASS_DESC },
			        draggableColumns: true,
			        paginator: POLAR.View.DataTable.createDefaultPaginator()
			    }
	        );

            POLAR.View.DataTable.configDataTable(dataTable);

            POLAR.View.DataTable.configDeleteUndelete({
                dataTable: dataTable,
                dataTableItems: resource.Items,
                dataTableDeleteButton: YAHOO.util.Dom.get('deleteButton'),
                dataTableUndeleteButton: YAHOO.util.Dom.get('undeleteButton')
            });

            //POLAR.View.createMenuOnTable(dataTable, 'dataTableContainer');
            //set with on first and second colon for beter visula efect
            $("#dataTableContainer table colgroup col:lt(1)").css('width', '10px');

        };
    </script>

    <script runat="server">
        string _jsonResRep;

        protected void Page_Load(object sender, EventArgs e)
        {
            PageHelper.RedirectToInstallationIfNoDatabaseFound();

            ApiHttpHandler apiHttpHandler = new ApiHttpHandler();
            ResourceHandlerResult responsePageRequest = apiHttpHandler.ProcessPageRequest(Context);
            _jsonResRep = responsePageRequest.JsonResourceRepresentation;
        }
    </script>
</body>
</html>
