<%@ Page Language="C#" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html class="resetpassword" xmlns="http://www.w3.org/1999/xhtml" >
<head>
    <title><%= ResetPasswordLabels.Title %></title>
    <polar:CssIncludes runat="server"/>
</head>
<body class="yui-skin-sam resetpassword">
    <div id="resetpassword-main">

        <div id="resetpassword-top"></div>
        <div id="resetpassword-body">
            <div id="resetpassword-panel">
                <div id="branding"><%= optionsService.HelpDeskTitle %></div>

                <div id="resetpassword-form">
                    <div>
                        <label><%= ResetPasswordLabels.Message %></label>
                    </div>
                    <div>
                        <label><%= CommonLabels.Password %></label>
                        <input id="password" type="password" class="psTextbox psLoginText" />
                    </div>
                    <div>
                        <label><%= CommonLabels.RepeatPassword%></label>
                        <input id="repeatPassword" type="password" class="psTextbox psLoginText" />
                    </div>
                    <div>
                        <input id="resetPasswordButton" type="button" value="<%= CommonLabels.SaveButton %>" />
                    </div>
                    <div>
                        <a href="<%= UrlHelper.GetUrl("login") %>"><%= CommonLabels.ReturnToLogin %></a>
                    </div>
                </div>
            </div>
        </div>
        <div id="resetpassword-bottom"></div>
    </div>

    <polar:Footer ID="Footer1" runat="server" />
    <script type="text/javascript">
        var resource = { "Errors": [], "Messages": [<% if (authenticationResult != AuthenticationResult.SuccessfullyAuthenticated ) {%> "<%= AuthenticationLabels.GetLabel(authenticationResult).ToString()%>" <% } %>] }
    </script>
    <polar:Includes ID="Includes1" runat="server" />

    <script type="text/javascript">
        $(document).ready(function() {
            POLAR.View.CheckForExtraInfo();
            POLAR.View.Page();
        });

        POLAR.View.Page = function() {
//	        YAHOO.util.Event.addListener(YAHOO.util.Dom.get('resetPasswordButton'), 'click', POLAR.View.Page.resetPassword);
            var oResetButton = new YAHOO.widget.Button("resetPasswordButton");
            oResetButton.on("click", POLAR.View.Page.resetPassword);
		};

		POLAR.View.Page.resetPassword = function() {
	        var passwordElement = YAHOO.util.Dom.get('password');
	        var repeatPasswordElement = YAHOO.util.Dom.get('repeatPassword');
		    var url = '<%= _resetPasswordResource.URI %>';

            var data =
            {
                 Password: passwordElement.value,
                 RepeatPassword: repeatPasswordElement.value
            };

		    POLAR.View.asyncPut(url, data, function(resetPassword) {
                passwordElement.value = '';
                repeatPasswordElement.value = '';

                alert('<%= ResetPasswordLabels.PasswordWasReset %>');
            });
	    };
    </script>
    <script runat="server">
        OptionsService optionsService = IoC.Container.Resolve<OptionsService>();
            ResetPasswordResource _resetPasswordResource;
        AuthenticationResult authenticationResult = AuthenticationResult.SuccessfullyAuthenticated;

        protected void Page_Load(object sender, EventArgs e)
        {
            ActionLogHelper.TrackRequest();
            PageHelper.RedirectToInstallationIfNoDatabaseFound();

            RequestedResource requestedResource = IoC.Container.Resolve<RequestedResource>();
            string guid = requestedResource.GetResource<ResetPasswordGUIDResourceURI>().GetUriVariableValue("GUID");
            _resetPasswordResource = new ResetPasswordResource(new ResetPasswordGUIDResourceURI(guid));
        }
    </script>
</body>
</html>

