<%@ Page Language="C#" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" >
<head>
    <title><%= SchedulerLabels.Title %></title>
    <polar:CssIncludes runat="server"/>
</head>
<body class="yui-skin-sam">
    <polar:Navigation runat="server" />
    <div id="resourceForm" <% if(HttpContext.Current.Response.StatusCode != 200){%> style="display: none" <% } %> >
    <div class="psFormToolbar">
    <input type="button" id="_runScheduler" value="Run Scheduler" /> <%= SchedulerLabels.SchedulerOptions %>
    </div>
        <p id="_schedulerStatus">
            <b><%= SchedulerLabels.SchedulerStatus %>:</b> <%= resource.Enabled.Value ? SchedulerLabels.SchedulerUpAndRunning : SchedulerLabels.SchedulerIsStoped %><br />
            <%= resource.IsCurrentlyExecuting.Value ? "<b>" + SchedulerLabels.SchedulerIsCurrentlyExecuting.ToString() + "</b>" : string.Empty %>
        </p>
        <p>            
            <table style="padding-top:10px;"="0" cellpadding="0" cellspacing="0">
                <tr>                    
                    <td style="padding-right:5px;"> <input type="checkbox" id="<%= resource.RunIndexingAllData.Name %>" checked="checked" /> </td>                    
                    <td> <%= SchedulerLabels.RunIndexingAllData%> </td>
                </tr>
                <tr>                    
                    <td><input type="checkbox" id="<%= resource.RunEmailAutomatization.Name %>" checked="checked" /></td>                    
                    <td> <%= SchedulerLabels.RunEmailAutomatizationService %></td>
                </tr>
                <tr>                    
                    <td><input type="checkbox" id="<%= resource.RunPriorityEscalation.Name %>" checked="checked" /></td>                    
                    <td> <%= SchedulerLabels.RunIncidentPriorityEscalationService %></td>
                </tr>
                <tr>                    
                    <td><input type="checkbox" id="<%= resource.RunActiveDirectorySynchronization.Name %>" checked="checked" /></td>                    
                    <td> <%= SchedulerLabels.SynchronizeDatabaseWithActiveDirectory %></td>
                </tr>
            </table>
        </p>
    </div>

    <polar:Footer runat="server" />
    <script type="text/javascript">
        var resource = <%=_jsonResRep%>;
    </script>
    <polar:Includes runat="server" />

    <script type="text/javascript">
		YAHOO.util.Event.addListener(window, 'load', function() {
		    POLAR.View.CheckForExtraInfo(); POLAR.View.Page();
		});

		POLAR.View.Page = function() {
		    POLAR.View.setTitleAndResourceName(resource.LabelsCommon.Scheduler);
	        // attach PUT request on run button just like we do on save button in standard resources
	        if ($('#_runScheduler').length) {
	            var oSaveButton = new YAHOO.widget.Button("_runScheduler");
	            oSaveButton.on("click", POLAR.View.Page.forceScheduler);
	        }
	    }

	    POLAR.View.Page.forceScheduler = function() {
	        var schedulerStatusElement = YAHOO.util.Dom.get('_schedulerStatus');
	        schedulerStatusElement.innerHTML = '<%= SchedulerLabels.WaitingForScheduler %>';

	        // from Polar.View.onSaveData
	        $("#messagebox").hide("fast");
	        var transaction = YAHOO.util.Connect.asyncRequest('PUT', POLAR.View.getUri(), POLAR.View.Page.requestCallback, POLAR.View.serializeData());
	    }

	    POLAR.View.Page.asyncResponse = function(request) {
	        YAHOO.util.Dom.get('messagebox').innerHTML = '';
	        YAHOO.util.Dom.get('_schedulerStatus').innerHTML = '<%= SchedulerLabels.SchedulerHasFinished %>';
	        POLAR.View.setAsyncResponseMessage(request);
	    }

	    POLAR.View.Page.requestCallback = {
	        success: POLAR.View.Page.asyncResponse,
	        failure: POLAR.View.Page.asyncResponse,
	        argument: POLAR.View.args
	    };
    </script>

    <script runat="server">
        SchedulerResource resource;
        string _jsonResRep;

	    protected void Page_Load(object sender, EventArgs e)
        {
            PageHelper.RedirectToInstallationIfNoDatabaseFound();
            ApiHttpHandler apiHttpHandler = new ApiHttpHandler();
            ResourceHandlerResult resourceHandlerResult = apiHttpHandler.ProcessPageRequest(Context);
            _jsonResRep = resourceHandlerResult.JsonResourceRepresentation;
            resource = resourceHandlerResult.EntityResoruceRepresentation as SchedulerResource;
        }
    </script>
</body>
</html>

