<%@ Page Language="C#" %>
<%@ Import Namespace="log4net.Core"%>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" >
<head>
    <polar:CssIncludes runat="server"/>
</head>
<body class="yui-skin-sam">
    <polar:Navigation runat="server" />
    <div id="resourceForm" <% if(HttpContext.Current.Response.StatusCode != 200 ){%> style="display: none" <% } %> >
    <div class="psFormToolbar">
	    <input id="buttonSave" <% if(!PageHelper.AuthorisePutRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.SaveButton %>" />
	</div>
	<table class="psFormTable" border="0" cellpadding="0" cellspacing="0" >
    <colgroup>
        <col class="psColon1">
        <col>
        <col class="psColMid">
        <col class="psColon3">
        <col>
    </colgroup>
    <tbody>
            <tr>
			    <td class="psFormCell psBar" colspan="5"><span><%= SettingsLabels.WelcomeMessage %></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell"></td>
                <td class="psFormCell" colspan="4">
                    <textarea class="psTextarea expand25-350 resizable" id="<%= resource.WelcomeMessage.Name %>"><%= resource.WelcomeMessage %></textarea>
                </td>
            </tr>

            <tr>
                <td class="psFormCell">
                    <span><%= SettingsLabels.HelpDeskTitle %></span>
                </td>
                <td class="psFormCell">
                    <input id="<%= resource.HelpDeskTitle.Name %>" class="psTextbox" value="<%= resource.HelpDeskTitle.Value %>" type="text" />
                </td>
                <td class="psFormMid"></td>
                <td class="psFormCell">
                </td>
                <td class="psFormCell">
                </td>
            </tr>

            <tr>
                <td class="psFormCell">
                    <span><%= SettingsLabels.registerContactTemplate %></span>
                    <span id="<%= resource.RegisterContactTemplate.Name + "error" %>"></span>
                </td>
                <td class="psFormCell">
                    <select id="RegisterContactTemplate.ID" class="styled">
		                <% foreach (ContactTemplate item in _contactTemplateRepository.GetAllNotDeletedTemplates())
                     {%>
		                <option value="<%= item.ID %>" <%= HtmlHelper.OptionSelect(null !=  resource.RegisterContactTemplate.Value && item.ID == resource.RegisterContactTemplate.Value.ID.Value) %>><%= item.Name %></option>
		                <% } %>
	                </select>
                </td>
			    <td class="psFormMid"></td>
                <td class="psFormCell">
                    <span><%= SettingsLabels.EnableScheduler %></span>
                    <span id="<%= resource.SchedulerEnabled.Name + "error" %>"></span>
                </td>
                <td class="psFormCell">
                    <input id="<%= resource.SchedulerEnabled.Name %>" name="<%= resource.SchedulerEnabled.Name %>" type="checkbox" <%= resource.SchedulerEnabled.Value ? "checked" : string.Empty %> />
                </td>
            </tr>
            <tr>
				<td class="psFormCell">
                    <span><%= SettingsLabels.DefaultNamespace %></span>
                    <span id="<%= resource.DefaultNamespace.Name + "error" %>"></span>
                </td>
                <td class="psFormCell">
                    <select id="DefaultNamespace.ID" class="styled">
		                <%
							foreach (Document item in _documentRepository.GetAllNamespaces())
							{
								if (!item.Deleted)
								{
									%><option value="<%= item.ID %>" <%= HtmlHelper.OptionSelect(null !=  resource.DefaultNamespace.Value && item.ID == resource.DefaultNamespace.Value.ID.Value) %>><%= item.Name%></option><%
								}
							}
                    	%>
	                </select>
                </td>
                <td class="psFormMid"></td>
                <td class="psFormCell">
                    <span><%= SettingsLabels.SetLogging%></span>
                </td>
                <td class="psFormCell">
                    <select id="<%= resource.LogLevel.Name %>" class="styled">
                        <option value="<%= Level.Debug.Value %>"><%= Level.Debug.DisplayName %></option>
                        <option value="<%= Level.Info.Value %>"><%= Level.Info.DisplayName %></option>
                        <option value="<%= Level.Warn.Value %>"><%= Level.Warn.DisplayName %></option>
                        <option value="<%= Level.Error.Value %>"><%= Level.Error.DisplayName %></option>
                        <option value="<%= Level.Off.Value %>"><%= Level.Off.DisplayName %></option>
                    </select>
                    <a href="<%= UrlHelper.GetUrl("/logs") %>"><%= SettingsLabels.ViewLogs %></a>
                </td>
            </tr>
            <tr>
                <td class="psFormCell">
                    <span><%= SettingsLabels.DefaultLanguage %></span>
                    <span id="<%= resource.DefaultLanguage.Name + "error" %>"></span>
                </td>
                <td class="psFormCell">
                    <select id="DefaultLanguage.ID" class="styled">
		                <% foreach (Language item in _languageRepository.GetAllLanguages()) {%>
		                <option value="<%= item.ID %>" <%= HtmlHelper.OptionSelect(null !=  resource.DefaultLanguage.Value && item.ID == resource.DefaultLanguage.Value.ID.Value) %>><%= item.Name %></option>
		                <% } %>
	                </select>
                </td>
                <td class="psFormMid"></td>
                <td class="psFormCell">
                    <span><%= SettingsLabels.TimeZone %></span>
                </td>
                <td class="psFormCell">
                    <select id="TimeZone" class="styled">
		                <% foreach (TimeZoneInfo item in TimeZoneInfo.GetSystemTimeZones()) {%>
		                <option id="<%= resource.TimeZone.Name %>" value="<%= item.Id %>" <%= HtmlHelper.OptionSelect(null !=  resource.TimeZone.Value && item.Id == resource.TimeZone.Value) %>><%= item.DisplayName%></option>
		                <% } %>
	                </select>
                </td>
            </tr>
            <tr>
                <td class="psFormCell">
                    <span><%= EmailAccountLabels.DefaultEmailAccount %></span>
                    <span id="<%= resource.DefaultEmailAccount + "error" %>"></span>
                </td>
                <td class="psFormCell">
                    <select id="DefaultEmailAccount.ID" class="styled">
		                <% 
							foreach (EmailAccount item in _emailAccountRepository.GetAll())
							{
								if (!item.Deleted)
								{
									%><option value="<%= item.ID %>" <%= HtmlHelper.OptionSelect(null !=  resource.DefaultEmailAccount.Value && item.ID == resource.DefaultEmailAccount.Value.ID.Value) %>><%= item.Name%></option><% 
								}
							}
						%>
	                </select>
                </td>
                <td class="psFormMid"></td>
                <td class="psFormCell">
                    <span><%= SettingsLabels.DateTimeFormat %></span>
                </td>
                <td class="psFormCell">
	                 <input id="<%= resource.DateTimeFormat.Name %>" class="psTextbox" value="<%= resource.DateTimeFormat.Value %>" type="text" />
	                 <a href="http://code.google.com/p/datejs/wiki/FormatSpecifiers">(Format List)</a>
                </td>
            </tr>
            <tr>
                <td class="psFormCell">
                    <span><%= SettingsLabels.DefaultServiceLevel %></span>
                </td>
                <td class="psFormCell">
                    <select id="DefaultServiceLevel.ID" class="styled">
		                <% 
							foreach (ServiceLevel item in _serviceLevelRepository.GetAll())
							{
								if (!item.Deleted)
								{
									%><option value="<%= item.ID %>" <%= HtmlHelper.OptionSelect(null !=  resource.DefaultServiceLevel.Value && item.ID == resource.DefaultServiceLevel.Value.ID.Value) %>><%= item.Name%></option><% 
								}
							}
                       	%>
	                </select>
                </td>
                <td class="psFormMid"></td>
                <td class="psFormCell">
                    <span><%= SettingsLabels.UseClientLocalDateTimeFormat %></span>
                </td>
                <td class="psFormCell">
                    <input id="<%= resource.OverrideDateTimeFormat.Name %>" name="<%= resource.OverrideDateTimeFormat.Name %>" type="checkbox" <%= resource.OverrideDateTimeFormat.Value ? "checked" : string.Empty %> />
                </td>
            </tr>
            
            <tr>
                <td class="psFormCell">
                    <span><%= IncidentLabels.ReportUser%></span>
                </td>
                <td class="psFormCell">
                    <div id="userLookup">
						<table border="0" cellpadding="0" cellspacing="0" >
							<tr >
								<td class="acbox">
									<div class="pl-autocomplete">
									    <input style="display:none" class="psTextbox pl-autocomplete-input" type="text" />
										<div class="pl-autocomplete-container" ></div>
									</div>
									<a id="userLink" href="<%= null != resource.ReportUser.Value ? resource.ReportUser.Value.URL.Value : string.Empty %>">	<%= null != resource.ReportUser.Value ? resource.ReportUser.Value.Name.Value : string.Empty%></a>
						           </td>
								<td class="lookupbtn">
									<button class="lookup pl-lookup-panel-show" ></button>
								</td>
							</tr>
						</table>
						<div class="resizablepanel pl-lookup-panel">
							<div class="bd">
								<div class="yui-skin-sam pl-lookup-datatable"></div>
							</div>
							<div class="ft"></div>
						</div>
					</div>
                </td>
                <td class="psFormMid"></td>
                <td class="psFormCell">
                </td>
                <td class="psFormCell">
                </td>
            </tr>
            
            <tr>
                <td class="psFormCell psBar" colspan="5">
                    <span><%= SettingsLabels.EmailSettings%></span>
                </td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>            
            <tr>
                <td class="psFormCell">
                    <span><%= SettingsLabels.EnableRegisterContactNotification%></span>
                </td>
                <td class="psFormCell">
                    <input id="<%= resource.EnableRegisterContactNotification.Name %>" name="<%= resource.EnableRegisterContactNotification.Name %>" type="checkbox" <%= resource.EnableRegisterContactNotification.Value ? "checked" : string.Empty %> />
                </td>
			    <td class="psFormMid"></td>
                <td class="psFormCell">
                    <span><%= SettingsLabels.EnableNewUserRegisteredEmailNotification%></span>
                </td>
                <td class="psFormCell">
                    <input id="<%= resource.EnableNewUserRegisteredEmailNotification.Name %>" name="<%= resource.EnableNewUserRegisteredEmailNotification.Name %>" type="checkbox" <%= resource.EnableNewUserRegisteredEmailNotification.Value ? "checked" : string.Empty %> />
                </td>
            </tr>
            
            <tr>
                <td class="psFormCell">
                    <span><%= SettingsLabels.HelpDeskUrl %></span>
                </td>
                <td class="psFormCell">
                    <input id="<%= resource.HelpDeskUrl.Name %>" class="psTextbox" value="<%= resource.HelpDeskUrl.Value %>" type="text" />
                </td>
                <td class="psFormMid"></td>
                <td class="psFormCell"></td>
                <td class="psFormCell"></td>
            </tr>
            
            <tr>
                <td class="psFormCell psBar" colspan="5">
                    <span><%= SettingsLabels.EmailNotificationTemplates %></span>
                </td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
				<td class="psFormCell">
                    <span><%= SettingsLabels.CreateUserEmailTemplate %></span>
                </td>
                <td class="psFormCell">
                    <select id="CreateUserEmailTemplate.ID" class="styled">
		                <%
							foreach (EmailTemplate item in emailTemplateRepository.GetAll())
							{
								if (!item.Deleted)
								{
									%><option value="<%= item.ID %>" <%= HtmlHelper.OptionSelect(null !=  resource.CreateUserEmailTemplate.Value && item.ID == resource.CreateUserEmailTemplate.Value.ID.Value) %>><%= item.Name%></option><%
								}
							}
                    	%>
	                </select>
                </td>
                <td class="psFormMid"></td>
                <td class="psFormCell">
                    <span><%= SettingsLabels.UpdateUserEmailTemplate %></span>
                </td>
                <td class="psFormCell">
                    <select id="UpdateUserEmailTemplate.ID" class="styled">
		                <%
							foreach (EmailTemplate item in emailTemplateRepository.GetAll())
							{
								if (!item.Deleted)
								{
									%><option value="<%= item.ID %>" <%= HtmlHelper.OptionSelect(null !=  resource.UpdateUserEmailTemplate.Value && item.ID == resource.UpdateUserEmailTemplate.Value.ID.Value) %>><%= item.Name%></option><%
								}
							}
                    	%>
	                </select>
                </td>
            </tr>

            <tr>
				<td class="psFormCell">
                    <span><%= SettingsLabels.ResetPasswordEmailTemplate%></span>
                </td>
                <td class="psFormCell">
                    <select id="ResetPasswordEmailTemplate.ID" class="styled">
		                <%
							foreach (EmailTemplate item in emailTemplateRepository.GetAll())
							{
								if (!item.Deleted)
								{
									%><option value="<%= item.ID %>" <%= HtmlHelper.OptionSelect(null !=  resource.ResetPasswordEmailTemplate.Value && item.ID == resource.ResetPasswordEmailTemplate.Value.ID.Value) %>><%= item.Name%></option><%
								}
							}
                    	%>
	                </select>
                </td>
                <td class="psFormMid"></td>
                <td class="psFormCell">
                    <span></span>
                </td>
                <td class="psFormCell">
                </td>
            </tr>
            
            <tr>
				<td class="psFormCell psBar" colspan="5"><span><%= SettingsLabels.HelpDeskUrlSection %></td>
            </tr>            
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell">
                    <span><%= SettingsLabels.InstanceUrl %> 1</span>
                </td>
                <td class="psFormCell">
                    <input id="InstanceUrl1" class="psTextbox" value="" type="text" />
                </td>
                <td class="psFormMid"></td>
                <td class="psFormCell"></td>
                <td class="psFormCell"></td>
            </tr>
            
            <tr>
                <td class="psFormCell">
                    <span><%= SettingsLabels.InstanceUrl %> 2</span>
                </td>
                <td class="psFormCell">
                    <input id="InstanceUrl2" class="psTextbox" value="" type="text" />
                </td>
                <td class="psFormMid"></td>
                <td class="psFormCell"></td>
                <td class="psFormCell"></td>
            </tr>
            
            <tr>
                <td class="psFormCell">
                    <span><%= SettingsLabels.InstanceUrl %> 3</span>
                </td>
                <td class="psFormCell">
                    <input id="InstanceUrl3" class="psTextbox" value="" type="text" />
                </td>
                <td class="psFormMid"></td>
                <td class="psFormCell"></td>
                <td class="psFormCell"></td>
            </tr>
        </tbody>
    </table>
  </div>

    <polar:Footer runat="server" />
    <script type="text/javascript">
        var resource = <%=_jsonResRep%>;
    </script>
    <polar:Includes runat="server" />

	<script type="text/javascript">
		YAHOO.util.Event.onDOMReady(function() {
			POLAR.View.CheckForExtraInfo();
			POLAR.View.Page();

			if (null == resource.Instances) {
				resource.Instances = [];
			}
			else {
				$("#InstanceUrl1").val(resource.Instances[0]);
				$("#InstanceUrl2").val(resource.Instances[1]);
				$("#InstanceUrl3").val(resource.Instances[2]);
			}

			$('#InstanceUrl1').bind("change keyup", function() { 
				resource.Instances[0] = $("#InstanceUrl1").val();
			});

			$('#InstanceUrl2').bind("change keyup", function() {
				resource.Instances[1] = $("#InstanceUrl2").val();
			});

			$('#InstanceUrl3').bind("change keyup", function() {
				resource.Instances[2] = $("#InstanceUrl3").val();
			});
		});

	    // when use locale checkbox is checked, disable custom format input
	    POLAR.View.ToogleCustomDateTimeFormatInput = function() {
	        var isChecked;

	        isChecked = $('input#<%= resource.OverrideDateTimeFormat.Name %>').attr('checked');
	        $('input#<%= resource.DateTimeFormat.Name %>').attr("disabled", isChecked);
	    }

	    POLAR.View.Page = function() {
	        POLAR.View.setTitleAndResourceName(resource.LabelsCommon.Settings);
	        POLAR.View.ToogleCustomDateTimeFormatInput();

	        $('input#<%= resource.OverrideDateTimeFormat.Name %>').change(POLAR.View.ToogleCustomDateTimeFormatInput);

	        autoCompleteLookupUser = new POLAR.Widget.AutoCompleteLookup({
	            id: 'userLookup',
	            url: '<%= UrlHelper.GetUrl("/api/users") %>',
	            urlItem: '<%= UrlHelper.GetUrl("/api/user/") %>',
	            linkID: "userLink",
	            propertyName: "ReportUser",
	            resourceHolder: resource,
	            autoCompleteData: { schema: ['ID', 'Name', 'Email'], query: '?maxresults=60&textsearch={0}*' },
	            lookupPanelData: {
	                fields: [{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber }, 'Name', 'Email', 'URL'],
	                columnDefinitions: [
                        { key: 'Add', formatter: 'customContact' },
	                    { key: 'ID', label: 'ID', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
                        { key: 'Name', label: 'Name', sortable: true, resizeable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl },
                        { key: 'Email', label: 'Email', sortable: true, resizeable: true }
                    ]
	            }
	        });

	        // select correct log level in drop down list
	        //$('#<%= resource.LogLevel.Name %>').val(<%= resource.LogLevel.Value %>); selected="selected"
	        //alert("<%= resource.LogLevel.Name %>");
	        //alert("<%= resource.LogLevel.Value %>");
	        //$('#LogLevel').val('60000');
	        $('#<%= resource.LogLevel.Name %>').val('<%= resource.LogLevel.Value %>');
	        $("select.styled").jqTransform();
	        //$('#LogLevelselectstyled').val(<%= resource.LogLevel.Value %>);
	        //$("#LogLevel option[value='60000'] ").attr('selected', 'selected');
	        
	        //$("#<%= resource.LogLevel.Name %> option[value='<%= resource.LogLevel.Value %>'] ").attr('selected', 'selected');
	        
	        
	    }
	</script>

    <script runat="server">
        SettingsResource resource;
        string _jsonResRep;

        ContactTemplateRepository _contactTemplateRepository = IoC.Container.Resolve<ContactTemplateRepository>();
		DocumentRepository _documentRepository = IoC.Container.Resolve<DocumentRepository>();
        LanguageRepository _languageRepository = IoC.Container.Resolve<LanguageRepository>();
        EmailAccountRepository _emailAccountRepository = IoC.Container.Resolve<EmailAccountRepository>();
		EmailTemplateRepository emailTemplateRepository = IoC.Container.Resolve<EmailTemplateRepository>();
        ServiceLevelRepository _serviceLevelRepository = IoC.Container.Resolve<ServiceLevelRepository>();
        //Logger _logger;

	    protected void Page_Load(object sender, EventArgs e)
	    {
            PageHelper.RedirectToInstallationIfNoDatabaseFound();

            //_logger = IoC.Container.Resolve<Logger>();

            ApiHttpHandler apiHttpHandler = new ApiHttpHandler();
            ResourceHandlerResult resourceHandlerResult = apiHttpHandler.ProcessPageRequest(Context);
            _jsonResRep = resourceHandlerResult.JsonResourceRepresentation;
            //_resource = (SettingsResource)responsePageRequest.Resource;
            resource = resourceHandlerResult.EntityResoruceRepresentation as SettingsResource;
        }
    </script>
</body>
</html>