<%@ Page Language="C#" %>
<%@ Import namespace="Newtonsoft.Json.Linq"%>
<%@ Import namespace="Polar.ServiceDesk.WebUserInterface.ResourceDefinitions"%>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" >
<head>
    <title><%= BusinessUnitLabels.TeamTitle%></title>
    <polar:CssIncludes runat="server"/>
</head>
<body class=" yui-skin-sam">
    <polar:Navigation runat="server" />
    <div id="resourceForm" <% if(HttpContext.Current.Response.StatusCode != 200 ){%> style="display: none" <% } %> >
    <div class="psFormToolbar">
    <table class="formActions" border="0" cellpadding="0" cellspacing="0">
        <tbody>
	    <tr>
	        <td style="text-align:left">
	            <div>
	                <% if(0 == resource.ID.Value) {
                    %>                    
                    <input id="buttonCreateAndOpen" <% if(!PageHelper.AuthorisePostRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.CreateAndRedirectButton %>" />
                    <input id="buttonCreate" <% if(!PageHelper.AuthorisePostRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.CreateButton %>" />
                    <%
                    }
                    else if (_businessUnitRepository.GetByIDWithoutDeletedFilter((long)resource.ID.Value, BusinessUnitType.Team).Deleted)
                    {
                    %>
                    <input id="buttonSave" <% if(!PageHelper.AuthorisePutRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.UndeleteButton %>" />
                    <%
                    } else {
                    %>
	                <input id="buttonSave" <% if(!PageHelper.AuthorisePutRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.SaveButton %>" />
                    <input id="buttonDelete" <% if(!PageHelper.AuthoriseDeleteRequest()) {%>disabled="disabled"<%}%> type="button" value="<%= CommonLabels.DeleteButton %>" />
                    <%
                    }
                    %>
                    <button id="categoryButtonId" type="button"><%= CommonLabels.Category%>...</button>
                </div>
	        </td>
	        <td style="text-align:right" >
	            <span class="primaryValue" ><%= CommonLabels.ID%>:</span> <input id="<%= IncidentResource.Meta.ID.Name %>" class="primaryValue" type="text" value="<%= resource.ID %>" readonly="readonly" />
	        </td>
		<tr>
		</tbody>
    </table>
    </div>
    <table class="psFormTable" border="0" cellpadding="0" cellspacing="0" >
        <colgroup>
	        <col class="psColon1">
	        <col>
	        <col class="psColMid">
	        <col class="psColon3">
	        <col>
	    </colgroup>
        <tbody>
            <tr>
                <td class="psFormCell psLabelRequire">
			        <span><%= CommonLabels.Name %></span>
			        <span id="<%= resource.Name.Name + "error" %>"></span>
			    </td>
			    <td class="psFormCell">
			        <input id="<%= resource.Name.Name %>" class="psTextbox" type="text" value="<%= resource.Name %>" />
			    </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell">
                    <span><%= BusinessUnitLabels.AssignableTeam %></span>
                </td>
                <td class="psFormCell">
					<input id="AssignableTeam" name="AssignableTeam" type="checkbox" <%= resource.AssignableTeam.Value ? "checked" : string.Empty %> />
                </td>
            </tr>
            <tr>
			    <td class="psFormCell psBar" colspan="5"><span><%= BusinessUnitLabels.EmailSettings%></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell">
			        <span><%= BusinessUnitLabels.EmailNotification %></span>
			    </td>
			    <td class="psFormCell">
			        <select id="EmailNotification.ID" class="styled">
		                <%
							foreach (EmailNotification item in _emailNotificationRepository.GetAll())
							{
								%><option value="<%= item.ID %>" <%= HtmlHelper.OptionSelect(null !=  resource.EmailNotification.Value && item.ID == resource.EmailNotification.Value.ID.Value) %>><%= item.Name %></option><%
							}
                    	%>
	                </select>
			    </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell">
			        <span><%= CommonLabels.EmailAccount %></span>
                </td>
                <td class="psFormCell">
                    <select id="EmailAccount.ID" class="styled">
                        <%
                            foreach (EmailAccount item in _emailAccountRepository.GetAll())
						    {
							    %><option value="<%= item.ID %>" <%= HtmlHelper.OptionSelect(null !=  resource.EmailAccount.Value && item.ID == resource.EmailAccount.Value.ID.Value) %>><%= item.Name %></option><%
						    }
                        %>
                    </select>
                </td>
            </tr>

            <tr>
			    <td class="psFormCell psBar" colspan="5"><span><%= BusinessUnitLabels.AddressAndTelephones %></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell">
			        <span><%= BusinessUnitLabels.Street %></span>
			        <span id="<%= resource.Street.Name + "error" %>"></span>
			    </td>
			    <td class="psFormCell">
			        <input id="<%= resource.Street.Name %>" class="psTextbox" type="text" value="<%= resource.Street %>" />
			    </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell">
                    <span><%= BusinessUnitLabels.MainPhone %></span>
                    <span id="<%= resource.MainPhone.Name + "error" %>"></span>
                </td>
                <td class="psFormCell">
                    <input id="<%= resource.MainPhone.Name %>" class="psTextbox" type="text" value="<%= resource.MainPhone %>" />
                </td>
            </tr>
            <tr>
                <td class="psFormCell">
                    <span><%= BusinessUnitLabels.City %></span>
                    <span id="<%= resource.City.Name + "error" %>"></span>
                </td>
                <td class="psFormCell">
                    <input id="<%= resource.City.Name %>" class="psTextbox" type="text" value="<%= resource.City %>" />
                </td>
			    <td class="psFormMid"></td>
                <td class="psFormCell">
			        <span><%= BusinessUnitLabels.OtherPhone %></span>
			        <span id="<%= resource.OtherPhone.Name + "error" %>"></span>
			    </td>
			    <td class="psFormCell">
			        <input id="<%= resource.OtherPhone.Name %>" class="psTextbox" type="text" value="<%= resource.OtherPhone %>" />
			    </td>
            </tr>
            <tr>
                <td class="psFormCell">
			        <span><%= BusinessUnitLabels.StateProvince %></span>
			        <span id="<%= resource.StateProvince.Name + "error" %>"></span>
			    </td>
			    <td class="psFormCell">
			        <input id="<%= resource.StateProvince.Name %>" class="psTextbox" type="text" value="<%= resource.StateProvince %>" />
			    </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell">
                    <span><%= BusinessUnitLabels.Fax %></span>
                    <span id="<%= resource.Fax.Name + "error" %>"></span>
                </td>
                <td class="psFormCell">
                    <input id="<%= resource.Fax.Name %>" class="psTextbox" type="text" value="<%= resource.Fax %>" />
                </td>
            </tr>
            <tr>
                <td class="psFormCell">
                    <span><%= BusinessUnitLabels.PostalCode %></span>
                    <span id="<%= resource.PostalCode.Name + "error" %>"></span>
                </td>
                <td class="psFormCell">
                    <input id="<%= resource.PostalCode.Name %>" class="psTextbox" type="text" value="<%= resource.PostalCode %>" />
                </td>
			    <td class="psFormMid"></td>
			    <td class="psFormCell">
                    <span><%= BusinessUnitLabels.Email %></span>
                    <span id="<%= resource.Email.Name + "error" %>"></span>
                </td>
                <td class="psFormCell">
                    <input id="<%= resource.Email.Name %>" class="psTextbox" type="text" value="<%= resource.Email %>" />
                </td>                
            </tr>
            <tr>
                <td class="psFormCell">
			        <span><%= CommonLabels.CountryRegion %></span>
			        <span id="<%= resource.CountryRegion.Name + "error" %>"></span>
			    </td>
			    <td class="psFormCell">
			        <select id="CountryRegion.ID" class="styled">
	                    <option value=""></option>
		                <% foreach (CountryRegion item in _countryRegionRepository.GetAll()) { %>
		                <option value="<%= item.ID %>" <%= HtmlHelper.OptionSelect(null !=  resource.CountryRegion.Value && item.ID == resource.CountryRegion.Value.ID.Value) %>><%= item.Name %></option>
		                <% } %>
	                </select>
			    </td>
			    <td class="psFormMid"></td>                
			    <td class="psFormCell">
			        <span><%= BusinessUnitLabels.WebSiteUrl %></span>
			        <span id="<%= resource.WebSiteUrl.Name + "error" %>"></span>
			    </td>
			    <td class="psFormCell">
			        <input id="<%= resource.WebSiteUrl.Name %>" class="psTextbox" type="text" value="<%= resource.WebSiteUrl %>" />
			    </td>
            </tr>
            <tr>
			    <td class="psFormCell psBar" colspan="5"><span><%= BusinessUnitLabels.Note %></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
                <td class="psFormCell"></td>
                <td class="psFormCell" colspan="4">
                    <textarea class="psTextarea expand25-350 resizable" id="<%= resource.Note.Name %>"><%= resource.Note%></textarea>
                </td>
            </tr>

            <tr>
			    <td class="psFormCell psBar" colspan="5"><span><%= BusinessUnitLabels.TeamMembers %></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
            <tr>
			    <td class="psFormCell"><span><%= BusinessUnitLabels.AddMember %></span></td>
                <td class="psFormCell">
                   <div id="userMembersLookup">
						<table border="0" cellpadding="0" cellspacing="0" >
							<tr >
								<td class="acbox">
									<div class="pl-autocomplete">
									    <input class="psTextbox pl-autocomplete-input" type="text" />
										<div class="pl-autocomplete-container" ></div>
									</div>
						           </td>
								<td class="lookupbtn">
									<button class="lookup pl-lookup-panel-show"> </button>
								</td>
							</tr>
						</table>

						<div class="resizablepanel pl-lookup-panel">							
							<div class="bd">
								<div class="yui-skin-sam pl-lookup-datatable"></div>
							</div>
							<div class="ft"></div>
						</div>
					</div>
                </td>            
            </tr>
            <tr>
                <td class="psFormCell"></td>
                <td class="psFormCell" colSpan="4"><div id="<%= TeamResource.Meta.Members.Name %>" class="yui-skin-sam"></div></td>
            </tr>
            <tr>           
                <td class="psFormCell">
					<span><%= BusinessUnitLabels.Language %></span>
                    <span id="<%= resource.Language.Name + "error" %>"></span>
			    </td>
			    <td class="psFormCell">
					<select id="Language.ID" class="styled">
                        <option value=""></option>
		                <% foreach (Language item in _languageRepository.GetAllLanguages()) {%>
		                <option value="<%= item.ID %>" <%= HtmlHelper.OptionSelect(null !=  resource.Language.Value && item.ID == resource.Language.Value.ID.Value) %>><%= item.Name %></option>
		                <% } %>
	                </select>
			    </td>
			    <td class="psFormMid"></td>
                <td class="psFormCell"></td>
                <td class="psFormCell"></td>
            </tr>
            <tr>
			    <td class="psFormCell psBar" colspan="5"><span><%= BusinessUnitLabels.Roles %></td>
            </tr>
            <tr class="psAfterBar" ><td></td></tr>
			<tr>
                <td class="psFormCell"></td>
                <td class="psFormCell" colSpan="4"><div id="<%= TeamResource.Meta.Roles.Name %>" class="yui-skin-sam"></div></td>
            </tr>

        </tbody>
    </table>
  
    </div>

    <polar:Footer runat="server" />
    <script type="text/javascript">
        var resource = <%= _jsonResRep %>

        /*Read all Category*/
        var categoriesAll = [];
        <%
            foreach (Category item in _categoryRepository.GetAll())
            {
        %>categoriesAll.push({ID:"<%= item.ID %>", Name:"<%= item.Name %>"});
        <%
            }
        %>

    </script>
   	<polar:Includes runat="server" />

   	<script type="text/javascript">
   	    var dataTable;  //MUST be outside of function for proper working of selectOrUnselectAllCheckboxes function
   	    YAHOO.util.Event.onDOMReady(function() {
   	        POLAR.View.CheckForExtraInfo();
   	        POLAR.View.Page();
		});

		POLAR.View.Page = function() {
		    POLAR.View.setTitleAndResourceName(resource.LabelsCommon.Team);
		    POLAR.View.CategoryButton(resource.Categories, categoriesAll, "categoryButtonId");

            /*Ezmaple of subdata
		    POLAR.Widget.AutoCompleteLookup.userParser = function(sData) {
		        return sData.Name;
		    }
		    fields: [{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber }, 'UserName', 'URL', 'FirstName', 'LastName', 'Email', { key: 'Language', parser: POLAR.Widget.AutoCompleteLookup.userParser}],
		    */

		    autoCompleteLookupUser = new POLAR.Widget.AutoCompleteLookup({
		        id: 'userMembersLookup',
		        url: '<%= UrlHelper.GetUrl("/api/users") %>',
		        urlItem: '<%= UrlHelper.GetUrl("/api/user/") %>',
		        propertyName: "User",
		        resourceHolder: resource,
		        autoCompleteData: { schema: ['ID', 'Name', 'Email'], query: '?maxresults=60&textsearch={0}*' },
		        lookupPanelData: {
		            fields: [{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber }, 'Name', 'Email', 'URL'],
		            columnDefinitions: [
                        { key: 'Add', formatter: 'customContact' },
	                    { key: 'ID', label: '<%= CommonLabels.ID %>', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
                        { key: 'Name', label: '<%= CommonLabels.Name%>', sortable: true, resizeable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl },
                        { key: 'Email', label: '<%= UserLabels.Email%>', sortable: true, resizeable: true }
                    ]
		        },
		        dataTableData:{
		            resourceName:"Members",
		            fields: [{ key: 'ID', parser: YAHOO.util.DataSource.parseNumber }, 'Name', 'URL', 'Email'],
		            columnDefinitions:[
                        { key: '' },
				        { key: 'ID', label: '<%= CommonLabels.ID %>', sortable: true, resizeable: true, sortOptions: { defaultOrder: 'desc'} },
				        { key: 'Name', label: '<%= CommonLabels.Name %>', sortable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl },				        
				        { key: 'Email', label: '<%= UserLabels.Email%>', sortable: true, formatter: POLAR.Widget.AutoCompleteLookup.dataTableFormatUrl }
				    ]
		        }
		    });

		    POLAR.View.Page.rolesDataTable = POLAR.View.Page.loadRolesDataTable();
		}

		POLAR.View.Page.loadRolesDataTable = function() {
			var dataSource = new YAHOO.util.DataSource(resource);
			dataSource.responseType = YAHOO.util.DataSource.TYPE_JSON;

			dataSource.responseSchema = {
			    resultsList: '<%= AccountResource.Meta.Roles.Name %>',
			    fields: [{ key: '<%= RoleResource.Meta.ID.Name %>', parser: YAHOO.util.DataSource.parseNumber }, '<%= RoleResource.Meta.Name.Name %>', '<%= RoleResource.Meta.URL.Name %>']
			};

			var columnDefinitions = [
				{ key: '<%= RoleResource.Meta.ID.Name %>', label: '<%= CommonLabels.ID %>', sortable: true, sortOptions: { defaultOrder: 'desc' }, resizeable: true },
				{ key: '<%= RoleResource.Meta.Name.Name %>', label: '<%= CommonLabels.Name %>', sortable: true, resizeable: true, formatter: POLAR.View.DataTable.formatUrl}];

			var configs = {
    		      draggableColumns:true
        	};

			var element = YAHOO.util.Dom.get('<%= AccountResource.Meta.Roles.Name %>');
			dataTable = new YAHOO.widget.DataTable(element, columnDefinitions, dataSource, configs);
			POLAR.View.setContainedObject(element, dataTable);

			POLAR.View.setDataTableRowReader(element, function(recordData) {
			    var data = new Object();
			    data['<%= RoleResource.Meta.ID.Name %>'] = recordData['<%= RoleResource.Meta.ID.Name %>'];
			    return data;
			});

			return dataTable;
		}
	</script>

	<script runat="server">
        CountryRegionRepository _countryRegionRepository = IoC.Container.Resolve<CountryRegionRepository>();
        LanguageRepository _languageRepository = IoC.Container.Resolve<LanguageRepository>();
        BusinessUnitRepository _businessUnitRepository = IoC.Container.Resolve<BusinessUnitRepository>();
		EmailNotificationRepository _emailNotificationRepository = IoC.Container.Resolve<EmailNotificationRepository>();
        EmailAccountRepository _emailAccountRepository = IoC.Container.Resolve<EmailAccountRepository>();
        CategoryRepository _categoryRepository = IoC.Container.Resolve<CategoryRepository>();

        TeamResource resource;
        string _jsonResRep;

        protected void Page_Load(object sender, EventArgs e)
        {
            PageHelper.RedirectToInstallationIfNoDatabaseFound();

            ApiHttpHandler apiHttpHandler = new ApiHttpHandler();
            ResourceHandlerResult resourceHandlerResult = apiHttpHandler.ProcessPageRequest(Context);
            _jsonResRep = resourceHandlerResult.JsonResourceRepresentation;
            resource = resourceHandlerResult.EntityResoruceRepresentation as TeamResource;
        }
    </script>
</body>
</html>