/* To prevent any potential data loss issues, you should review this script in detail before running it outside the context of the database designer.*/
BEGIN TRANSACTION
SET QUOTED_IDENTIFIER ON
SET ARITHABORT ON
SET NUMERIC_ROUNDABORT OFF
SET CONCAT_NULL_YIELDS_NULL ON
SET ANSI_NULLS ON
SET ANSI_PADDING ON
SET ANSI_WARNINGS ON
COMMIT
BEGIN TRANSACTION
GO
ALTER TABLE dbo.Incident
	DROP CONSTRAINT FK_Incidents_IncidentStatuses
GO
ALTER TABLE dbo.IncidentStatus SET (LOCK_ESCALATION = TABLE)
GO
COMMIT
select Has_Perms_By_Name(N'dbo.IncidentStatus', 'Object', 'ALTER') as ALT_Per, Has_Perms_By_Name(N'dbo.IncidentStatus', 'Object', 'VIEW DEFINITION') as View_def_Per, Has_Perms_By_Name(N'dbo.IncidentStatus', 'Object', 'CONTROL') as Contr_Per BEGIN TRANSACTION
GO
ALTER TABLE dbo.Incident
	DROP CONSTRAINT FK_Incidents_ClosureClassifcations
GO
ALTER TABLE dbo.ClosureClassification SET (LOCK_ESCALATION = TABLE)
GO
COMMIT
select Has_Perms_By_Name(N'dbo.ClosureClassification', 'Object', 'ALTER') as ALT_Per, Has_Perms_By_Name(N'dbo.ClosureClassification', 'Object', 'VIEW DEFINITION') as View_def_Per, Has_Perms_By_Name(N'dbo.ClosureClassification', 'Object', 'CONTROL') as Contr_Per BEGIN TRANSACTION
GO
ALTER TABLE dbo.Incident
	DROP CONSTRAINT FK_Incident_Users_Assignee
GO
ALTER TABLE dbo.Incident
	DROP CONSTRAINT FK_Incident_Users_CreatedBy
GO
ALTER TABLE dbo.Incident
	DROP CONSTRAINT FK_Incidents_Users_ContactID
GO
ALTER TABLE dbo.Users SET (LOCK_ESCALATION = TABLE)
GO
COMMIT
select Has_Perms_By_Name(N'dbo.Users', 'Object', 'ALTER') as ALT_Per, Has_Perms_By_Name(N'dbo.Users', 'Object', 'VIEW DEFINITION') as View_def_Per, Has_Perms_By_Name(N'dbo.Users', 'Object', 'CONTROL') as Contr_Per BEGIN TRANSACTION
GO
ALTER TABLE dbo.Incident
	DROP CONSTRAINT FK_Incident_Urgency
GO
ALTER TABLE dbo.Urgency SET (LOCK_ESCALATION = TABLE)
GO
COMMIT
select Has_Perms_By_Name(N'dbo.Urgency', 'Object', 'ALTER') as ALT_Per, Has_Perms_By_Name(N'dbo.Urgency', 'Object', 'VIEW DEFINITION') as View_def_Per, Has_Perms_By_Name(N'dbo.Urgency', 'Object', 'CONTROL') as Contr_Per BEGIN TRANSACTION
GO
ALTER TABLE dbo.Incident
	DROP CONSTRAINT FK_Incident_Service
GO
ALTER TABLE dbo.Service SET (LOCK_ESCALATION = TABLE)
GO
COMMIT
select Has_Perms_By_Name(N'dbo.Service', 'Object', 'ALTER') as ALT_Per, Has_Perms_By_Name(N'dbo.Service', 'Object', 'VIEW DEFINITION') as View_def_Per, Has_Perms_By_Name(N'dbo.Service', 'Object', 'CONTROL') as Contr_Per BEGIN TRANSACTION
GO
ALTER TABLE dbo.Incident
	DROP CONSTRAINT FK_Incident_Priority
GO
ALTER TABLE dbo.Priority SET (LOCK_ESCALATION = TABLE)
GO
COMMIT
select Has_Perms_By_Name(N'dbo.Priority', 'Object', 'ALTER') as ALT_Per, Has_Perms_By_Name(N'dbo.Priority', 'Object', 'VIEW DEFINITION') as View_def_Per, Has_Perms_By_Name(N'dbo.Priority', 'Object', 'CONTROL') as Contr_Per BEGIN TRANSACTION
GO
ALTER TABLE dbo.Incident
	DROP CONSTRAINT FK_Incident_IncidentTemplate
GO
ALTER TABLE dbo.IncidentTemplate SET (LOCK_ESCALATION = TABLE)
GO
COMMIT
select Has_Perms_By_Name(N'dbo.IncidentTemplate', 'Object', 'ALTER') as ALT_Per, Has_Perms_By_Name(N'dbo.IncidentTemplate', 'Object', 'VIEW DEFINITION') as View_def_Per, Has_Perms_By_Name(N'dbo.IncidentTemplate', 'Object', 'CONTROL') as Contr_Per BEGIN TRANSACTION
GO
ALTER TABLE dbo.Incident
	DROP CONSTRAINT FK_Incident_IncidentOrigin
GO
ALTER TABLE dbo.IncidentOrigin SET (LOCK_ESCALATION = TABLE)
GO
COMMIT
select Has_Perms_By_Name(N'dbo.IncidentOrigin', 'Object', 'ALTER') as ALT_Per, Has_Perms_By_Name(N'dbo.IncidentOrigin', 'Object', 'VIEW DEFINITION') as View_def_Per, Has_Perms_By_Name(N'dbo.IncidentOrigin', 'Object', 'CONTROL') as Contr_Per BEGIN TRANSACTION
GO
ALTER TABLE dbo.Incident
	DROP CONSTRAINT FK_Incident_Impact
GO
ALTER TABLE dbo.Impact SET (LOCK_ESCALATION = TABLE)
GO
COMMIT
select Has_Perms_By_Name(N'dbo.Impact', 'Object', 'ALTER') as ALT_Per, Has_Perms_By_Name(N'dbo.Impact', 'Object', 'VIEW DEFINITION') as View_def_Per, Has_Perms_By_Name(N'dbo.Impact', 'Object', 'CONTROL') as Contr_Per BEGIN TRANSACTION
GO
ALTER TABLE dbo.Incident
	DROP CONSTRAINT FK_Incident_ConfigurationItem
GO
ALTER TABLE dbo.ConfigurationItem SET (LOCK_ESCALATION = TABLE)
GO
COMMIT
select Has_Perms_By_Name(N'dbo.ConfigurationItem', 'Object', 'ALTER') as ALT_Per, Has_Perms_By_Name(N'dbo.ConfigurationItem', 'Object', 'VIEW DEFINITION') as View_def_Per, Has_Perms_By_Name(N'dbo.ConfigurationItem', 'Object', 'CONTROL') as Contr_Per BEGIN TRANSACTION
GO
ALTER TABLE dbo.Incident
	DROP CONSTRAINT FK_Incident_AssigneeBusinessUnit
GO
ALTER TABLE dbo.Incident
	DROP CONSTRAINT FK_Incident_BusinessUnit
GO
ALTER TABLE dbo.BusinessUnit SET (LOCK_ESCALATION = TABLE)
GO
COMMIT
select Has_Perms_By_Name(N'dbo.BusinessUnit', 'Object', 'ALTER') as ALT_Per, Has_Perms_By_Name(N'dbo.BusinessUnit', 'Object', 'VIEW DEFINITION') as View_def_Per, Has_Perms_By_Name(N'dbo.BusinessUnit', 'Object', 'CONTROL') as Contr_Per BEGIN TRANSACTION
GO
ALTER TABLE dbo.Incident
	DROP CONSTRAINT DF_Incident_ServiceID
GO
ALTER TABLE dbo.Incident
	DROP CONSTRAINT DF_Incident_ModifiedBy
GO
ALTER TABLE dbo.Incident
	DROP CONSTRAINT DF_Incident_UpdatedDate
GO
ALTER TABLE dbo.Incident
	DROP CONSTRAINT DF_Incident_CreatedDate
GO
ALTER TABLE dbo.Incident
	DROP CONSTRAINT DF_Incident_Version
GO
ALTER TABLE dbo.Incident
	DROP CONSTRAINT DF_Incident_HiddenIncident
GO
ALTER TABLE dbo.Incident
	DROP CONSTRAINT DF_Incident_Spam
GO
ALTER TABLE dbo.Incident
	DROP CONSTRAINT DF_Incident_Deleted
GO
ALTER TABLE dbo.Incident
	DROP CONSTRAINT DF_Incident_InternalOrigin
GO
CREATE TABLE dbo.Tmp_Incident
	(
	IncidentID bigint NOT NULL IDENTITY (1, 1),
	CreatedBy bigint NULL,
	Title nvarchar(256) NOT NULL,
	ContactID bigint NULL,
	IncidentStatusID bigint NOT NULL,
	UrgencyID bigint NULL,
	ImpactID bigint NULL,
	PriorityID bigint NOT NULL,
	TeamID bigint NULL,
	ClosureClassificationID bigint NULL,
	IncidentOriginID bigint NULL,
	AssigneeID bigint NULL,
	AccountID bigint NULL,
	ServiceID bigint NULL,
	Description nvarchar(MAX) NULL,
	Resolution nvarchar(MAX) NULL,
	Note nvarchar(MAX) NULL,
	ModifiedBy bigint NULL,
	ModifiedOn datetime NOT NULL,
	CreatedOn datetime NOT NULL,
	ConfigurationItemID bigint NULL,
	Version bigint NOT NULL,
	HiddenIncident bit NOT NULL,
	Spam int NULL,
	Deleted bit NOT NULL,
	Conversation nvarchar(MAX) NULL,
	CustomData nvarchar(MAX) NULL,
	InternalOrigin int NULL,
	IncidentTemplateID bigint NULL,
	Data nvarchar(MAX) NULL
	)  ON [PRIMARY]
	 TEXTIMAGE_ON [PRIMARY]
GO
ALTER TABLE dbo.Tmp_Incident SET (LOCK_ESCALATION = TABLE)
GO
ALTER TABLE dbo.Tmp_Incident ADD CONSTRAINT
	DF_Incident_ServiceID DEFAULT ((1)) FOR ServiceID
GO
ALTER TABLE dbo.Tmp_Incident ADD CONSTRAINT
	DF_Incident_ModifiedBy DEFAULT (NULL) FOR ModifiedBy
GO
ALTER TABLE dbo.Tmp_Incident ADD CONSTRAINT
	DF_Incident_UpdatedDate DEFAULT (getdate()) FOR ModifiedOn
GO
ALTER TABLE dbo.Tmp_Incident ADD CONSTRAINT
	DF_Incident_CreatedDate DEFAULT (getdate()) FOR CreatedOn
GO
ALTER TABLE dbo.Tmp_Incident ADD CONSTRAINT
	DF_Incident_Version DEFAULT ((1)) FOR Version
GO
ALTER TABLE dbo.Tmp_Incident ADD CONSTRAINT
	DF_Incident_HiddenIncident DEFAULT ((0)) FOR HiddenIncident
GO
ALTER TABLE dbo.Tmp_Incident ADD CONSTRAINT
	DF_Incident_Spam DEFAULT ((0)) FOR Spam
GO
ALTER TABLE dbo.Tmp_Incident ADD CONSTRAINT
	DF_Incident_Deleted DEFAULT ((0)) FOR Deleted
GO
ALTER TABLE dbo.Tmp_Incident ADD CONSTRAINT
	DF_Incident_InternalOrigin DEFAULT ((0)) FOR InternalOrigin
GO
SET IDENTITY_INSERT dbo.Tmp_Incident ON
GO
IF EXISTS(SELECT * FROM dbo.Incident)
	 EXEC('INSERT INTO dbo.Tmp_Incident (IncidentID, CreatedBy, Title, ContactID, IncidentStatusID, UrgencyID, ImpactID, PriorityID, TeamID, ClosureClassificationID, IncidentOriginID, AssigneeID, AccountID, ServiceID, Description, Resolution, Note, ModifiedBy, ModifiedOn, CreatedOn, ConfigurationItemID, Version, HiddenIncident, Spam, Deleted, Conversation, CustomData, InternalOrigin, IncidentTemplateID, Data)
		SELECT IncidentID, CreatedBy, Title, ContactID, IncidentStatusID, UrgencyID, ImpactID, PriorityID, TeamID, ClosureClassificationID, IncidentOriginID, AssigneeID, AccountID, ServiceID, Description, Resolution, Note, ModifiedBy, ModifiedOn, CreatedOn, ConfigurationItemID, Version, HiddenIncident, Spam, Deleted, Conversation, CustomData, InternalOrigin, IncidentTemplateID, Data FROM dbo.Incident WITH (HOLDLOCK TABLOCKX)')
GO
SET IDENTITY_INSERT dbo.Tmp_Incident OFF
GO
ALTER TABLE dbo.IncidentHistory
	DROP CONSTRAINT FK_IncidentHistory_Incident
GO
ALTER TABLE dbo.Read_IncidentUser
	DROP CONSTRAINT FK_ReadIncidentUser_Incident
GO
ALTER TABLE dbo.Category_Incident
	DROP CONSTRAINT FK_Category_Incident_Category_Incident
GO
ALTER TABLE dbo.AutomationFile
	DROP CONSTRAINT FK_AutomationFile_Incident
GO
ALTER TABLE dbo.WorkOrder
	DROP CONSTRAINT FK_WorkOrder_Incident
GO
ALTER TABLE dbo.WorkOrderTemplate
	DROP CONSTRAINT FK_WorkOrderTemplate_Incidents
GO
ALTER TABLE dbo.WorkOrderHistory
	DROP CONSTRAINT FK_WorkOrderHistory_Incident
GO
DROP TABLE dbo.Incident
GO
EXECUTE sp_rename N'dbo.Tmp_Incident', N'Incident', 'OBJECT' 
GO
ALTER TABLE dbo.Incident ADD CONSTRAINT
	PK_Incidents PRIMARY KEY CLUSTERED 
	(
	IncidentID
	) WITH( STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]

GO
ALTER TABLE dbo.Incident ADD CONSTRAINT
	FK_Incident_AssigneeBusinessUnit FOREIGN KEY
	(
	TeamID
	) REFERENCES dbo.BusinessUnit
	(
	BusinessUnitID
	) ON UPDATE  NO ACTION 
	 ON DELETE  NO ACTION 
	
GO
ALTER TABLE dbo.Incident WITH NOCHECK ADD CONSTRAINT
	FK_Incident_BusinessUnit FOREIGN KEY
	(
	AccountID
	) REFERENCES dbo.BusinessUnit
	(
	BusinessUnitID
	) ON UPDATE  NO ACTION 
	 ON DELETE  NO ACTION 
	
GO
ALTER TABLE dbo.Incident
	NOCHECK CONSTRAINT FK_Incident_BusinessUnit
GO
ALTER TABLE dbo.Incident WITH NOCHECK ADD CONSTRAINT
	FK_Incident_ConfigurationItem FOREIGN KEY
	(
	ConfigurationItemID
	) REFERENCES dbo.ConfigurationItem
	(
	ConfigurationItemID
	) ON UPDATE  NO ACTION 
	 ON DELETE  NO ACTION 
	
GO
ALTER TABLE dbo.Incident
	NOCHECK CONSTRAINT FK_Incident_ConfigurationItem
GO
ALTER TABLE dbo.Incident WITH NOCHECK ADD CONSTRAINT
	FK_Incident_Impact FOREIGN KEY
	(
	ImpactID
	) REFERENCES dbo.Impact
	(
	ImpactID
	) ON UPDATE  NO ACTION 
	 ON DELETE  NO ACTION 
	
GO
ALTER TABLE dbo.Incident
	NOCHECK CONSTRAINT FK_Incident_Impact
GO
ALTER TABLE dbo.Incident WITH NOCHECK ADD CONSTRAINT
	FK_Incident_IncidentOrigin FOREIGN KEY
	(
	IncidentOriginID
	) REFERENCES dbo.IncidentOrigin
	(
	IncidentOriginID
	) ON UPDATE  NO ACTION 
	 ON DELETE  NO ACTION 
	
GO
ALTER TABLE dbo.Incident
	NOCHECK CONSTRAINT FK_Incident_IncidentOrigin
GO
ALTER TABLE dbo.Incident ADD CONSTRAINT
	FK_Incident_IncidentTemplate FOREIGN KEY
	(
	IncidentTemplateID
	) REFERENCES dbo.IncidentTemplate
	(
	IncidentTemplateID
	) ON UPDATE  NO ACTION 
	 ON DELETE  NO ACTION 
	
GO
ALTER TABLE dbo.Incident ADD CONSTRAINT
	FK_Incident_Priority FOREIGN KEY
	(
	PriorityID
	) REFERENCES dbo.Priority
	(
	PriorityID
	) ON UPDATE  NO ACTION 
	 ON DELETE  NO ACTION 
	
GO
ALTER TABLE dbo.Incident ADD CONSTRAINT
	FK_Incident_Service FOREIGN KEY
	(
	ServiceID
	) REFERENCES dbo.Service
	(
	ServiceID
	) ON UPDATE  NO ACTION 
	 ON DELETE  NO ACTION 
	
GO
ALTER TABLE dbo.Incident WITH NOCHECK ADD CONSTRAINT
	FK_Incident_Urgency FOREIGN KEY
	(
	UrgencyID
	) REFERENCES dbo.Urgency
	(
	UrgencyID
	) ON UPDATE  NO ACTION 
	 ON DELETE  NO ACTION 
	
GO
ALTER TABLE dbo.Incident
	NOCHECK CONSTRAINT FK_Incident_Urgency
GO
ALTER TABLE dbo.Incident ADD CONSTRAINT
	FK_Incident_Users_Assignee FOREIGN KEY
	(
	AssigneeID
	) REFERENCES dbo.Users
	(
	UserID
	) ON UPDATE  NO ACTION 
	 ON DELETE  NO ACTION 
	
GO
ALTER TABLE dbo.Incident ADD CONSTRAINT
	FK_Incident_Users_CreatedBy FOREIGN KEY
	(
	CreatedBy
	) REFERENCES dbo.Users
	(
	UserID
	) ON UPDATE  NO ACTION 
	 ON DELETE  NO ACTION 
	
GO
ALTER TABLE dbo.Incident WITH NOCHECK ADD CONSTRAINT
	FK_Incidents_ClosureClassifcations FOREIGN KEY
	(
	ClosureClassificationID
	) REFERENCES dbo.ClosureClassification
	(
	ClosureClassificationID
	) ON UPDATE  NO ACTION 
	 ON DELETE  NO ACTION 
	
GO
ALTER TABLE dbo.Incident
	NOCHECK CONSTRAINT FK_Incidents_ClosureClassifcations
GO
ALTER TABLE dbo.Incident ADD CONSTRAINT
	FK_Incidents_IncidentStatuses FOREIGN KEY
	(
	IncidentStatusID
	) REFERENCES dbo.IncidentStatus
	(
	IncidentStatusID
	) ON UPDATE  NO ACTION 
	 ON DELETE  NO ACTION 
	
GO
ALTER TABLE dbo.Incident ADD CONSTRAINT
	FK_Incidents_Users_ContactID FOREIGN KEY
	(
	ContactID
	) REFERENCES dbo.Users
	(
	UserID
	) ON UPDATE  NO ACTION 
	 ON DELETE  NO ACTION 
	
GO
COMMIT
select Has_Perms_By_Name(N'dbo.Incident', 'Object', 'ALTER') as ALT_Per, Has_Perms_By_Name(N'dbo.Incident', 'Object', 'VIEW DEFINITION') as View_def_Per, Has_Perms_By_Name(N'dbo.Incident', 'Object', 'CONTROL') as Contr_Per BEGIN TRANSACTION
GO
ALTER TABLE dbo.WorkOrderHistory WITH NOCHECK ADD CONSTRAINT
	FK_WorkOrderHistory_Incident FOREIGN KEY
	(
	IncidentID
	) REFERENCES dbo.Incident
	(
	IncidentID
	) ON UPDATE  NO ACTION 
	 ON DELETE  NO ACTION 
	
GO
ALTER TABLE dbo.WorkOrderHistory SET (LOCK_ESCALATION = TABLE)
GO
COMMIT
select Has_Perms_By_Name(N'dbo.WorkOrderHistory', 'Object', 'ALTER') as ALT_Per, Has_Perms_By_Name(N'dbo.WorkOrderHistory', 'Object', 'VIEW DEFINITION') as View_def_Per, Has_Perms_By_Name(N'dbo.WorkOrderHistory', 'Object', 'CONTROL') as Contr_Per BEGIN TRANSACTION
GO
ALTER TABLE dbo.WorkOrderTemplate ADD CONSTRAINT
	FK_WorkOrderTemplate_Incidents FOREIGN KEY
	(
	IncidentID
	) REFERENCES dbo.Incident
	(
	IncidentID
	) ON UPDATE  NO ACTION 
	 ON DELETE  NO ACTION 
	
GO
ALTER TABLE dbo.WorkOrderTemplate SET (LOCK_ESCALATION = TABLE)
GO
COMMIT
select Has_Perms_By_Name(N'dbo.WorkOrderTemplate', 'Object', 'ALTER') as ALT_Per, Has_Perms_By_Name(N'dbo.WorkOrderTemplate', 'Object', 'VIEW DEFINITION') as View_def_Per, Has_Perms_By_Name(N'dbo.WorkOrderTemplate', 'Object', 'CONTROL') as Contr_Per BEGIN TRANSACTION
GO
ALTER TABLE dbo.WorkOrder WITH NOCHECK ADD CONSTRAINT
	FK_WorkOrder_Incident FOREIGN KEY
	(
	IncidentID
	) REFERENCES dbo.Incident
	(
	IncidentID
	) ON UPDATE  NO ACTION 
	 ON DELETE  NO ACTION 
	
GO
ALTER TABLE dbo.WorkOrder SET (LOCK_ESCALATION = TABLE)
GO
COMMIT
select Has_Perms_By_Name(N'dbo.WorkOrder', 'Object', 'ALTER') as ALT_Per, Has_Perms_By_Name(N'dbo.WorkOrder', 'Object', 'VIEW DEFINITION') as View_def_Per, Has_Perms_By_Name(N'dbo.WorkOrder', 'Object', 'CONTROL') as Contr_Per BEGIN TRANSACTION
GO
ALTER TABLE dbo.AutomationFile ADD CONSTRAINT
	FK_AutomationFile_Incident FOREIGN KEY
	(
	IncidentID
	) REFERENCES dbo.Incident
	(
	IncidentID
	) ON UPDATE  NO ACTION 
	 ON DELETE  CASCADE 
	
GO
ALTER TABLE dbo.AutomationFile SET (LOCK_ESCALATION = TABLE)
GO
COMMIT
select Has_Perms_By_Name(N'dbo.AutomationFile', 'Object', 'ALTER') as ALT_Per, Has_Perms_By_Name(N'dbo.AutomationFile', 'Object', 'VIEW DEFINITION') as View_def_Per, Has_Perms_By_Name(N'dbo.AutomationFile', 'Object', 'CONTROL') as Contr_Per BEGIN TRANSACTION
GO
ALTER TABLE dbo.Category_Incident ADD CONSTRAINT
	FK_Category_Incident_Category_Incident FOREIGN KEY
	(
	IncidentID
	) REFERENCES dbo.Incident
	(
	IncidentID
	) ON UPDATE  NO ACTION 
	 ON DELETE  NO ACTION 
	
GO
ALTER TABLE dbo.Category_Incident SET (LOCK_ESCALATION = TABLE)
GO
COMMIT
select Has_Perms_By_Name(N'dbo.Category_Incident', 'Object', 'ALTER') as ALT_Per, Has_Perms_By_Name(N'dbo.Category_Incident', 'Object', 'VIEW DEFINITION') as View_def_Per, Has_Perms_By_Name(N'dbo.Category_Incident', 'Object', 'CONTROL') as Contr_Per BEGIN TRANSACTION
GO
ALTER TABLE dbo.Read_IncidentUser ADD CONSTRAINT
	FK_ReadIncidentUser_Incident FOREIGN KEY
	(
	IncidentID
	) REFERENCES dbo.Incident
	(
	IncidentID
	) ON UPDATE  NO ACTION 
	 ON DELETE  CASCADE 
	
GO
ALTER TABLE dbo.Read_IncidentUser SET (LOCK_ESCALATION = TABLE)
GO
COMMIT
select Has_Perms_By_Name(N'dbo.Read_IncidentUser', 'Object', 'ALTER') as ALT_Per, Has_Perms_By_Name(N'dbo.Read_IncidentUser', 'Object', 'VIEW DEFINITION') as View_def_Per, Has_Perms_By_Name(N'dbo.Read_IncidentUser', 'Object', 'CONTROL') as Contr_Per BEGIN TRANSACTION
GO
ALTER TABLE dbo.IncidentHistory ADD CONSTRAINT
	FK_IncidentHistory_Incident FOREIGN KEY
	(
	IncidentID
	) REFERENCES dbo.Incident
	(
	IncidentID
	) ON UPDATE  NO ACTION 
	 ON DELETE  CASCADE 
	
GO
ALTER TABLE dbo.IncidentHistory SET (LOCK_ESCALATION = TABLE)
GO
COMMIT
select Has_Perms_By_Name(N'dbo.IncidentHistory', 'Object', 'ALTER') as ALT_Per, Has_Perms_By_Name(N'dbo.IncidentHistory', 'Object', 'VIEW DEFINITION') as View_def_Per, Has_Perms_By_Name(N'dbo.IncidentHistory', 'Object', 'CONTROL') as Contr_Per 




/* To prevent any potential data loss issues, you should review this script in detail before running it outside the context of the database designer.*/
BEGIN TRANSACTION
SET QUOTED_IDENTIFIER ON
SET ARITHABORT ON
SET NUMERIC_ROUNDABORT OFF
SET CONCAT_NULL_YIELDS_NULL ON
SET ANSI_NULLS ON
SET ANSI_PADDING ON
SET ANSI_WARNINGS ON
COMMIT
BEGIN TRANSACTION
GO
ALTER TABLE dbo.IncidentHistory
	DROP CONSTRAINT FK_IncidentHistory_Users
GO
ALTER TABLE dbo.IncidentHistory
	DROP CONSTRAINT FK_IncidentHistory_Users_Assignee
GO
ALTER TABLE dbo.IncidentHistory
	DROP CONSTRAINT FK_IncidentHistory_Users_ContactID
GO
ALTER TABLE dbo.IncidentHistory
	DROP CONSTRAINT FK_IncidentHistory_Users_CreatedBy
GO
ALTER TABLE dbo.Users SET (LOCK_ESCALATION = TABLE)
GO
COMMIT
select Has_Perms_By_Name(N'dbo.Users', 'Object', 'ALTER') as ALT_Per, Has_Perms_By_Name(N'dbo.Users', 'Object', 'VIEW DEFINITION') as View_def_Per, Has_Perms_By_Name(N'dbo.Users', 'Object', 'CONTROL') as Contr_Per BEGIN TRANSACTION
GO
ALTER TABLE dbo.IncidentHistory
	DROP CONSTRAINT FK_IncidentHistory_Urgency
GO
ALTER TABLE dbo.Urgency SET (LOCK_ESCALATION = TABLE)
GO
COMMIT
select Has_Perms_By_Name(N'dbo.Urgency', 'Object', 'ALTER') as ALT_Per, Has_Perms_By_Name(N'dbo.Urgency', 'Object', 'VIEW DEFINITION') as View_def_Per, Has_Perms_By_Name(N'dbo.Urgency', 'Object', 'CONTROL') as Contr_Per BEGIN TRANSACTION
GO
ALTER TABLE dbo.IncidentHistory
	DROP CONSTRAINT FK_IncidentHistory_Service
GO
ALTER TABLE dbo.Service SET (LOCK_ESCALATION = TABLE)
GO
COMMIT
select Has_Perms_By_Name(N'dbo.Service', 'Object', 'ALTER') as ALT_Per, Has_Perms_By_Name(N'dbo.Service', 'Object', 'VIEW DEFINITION') as View_def_Per, Has_Perms_By_Name(N'dbo.Service', 'Object', 'CONTROL') as Contr_Per BEGIN TRANSACTION
GO
ALTER TABLE dbo.IncidentHistory
	DROP CONSTRAINT FK_IncidentHistory_Priority
GO
ALTER TABLE dbo.Priority SET (LOCK_ESCALATION = TABLE)
GO
COMMIT
select Has_Perms_By_Name(N'dbo.Priority', 'Object', 'ALTER') as ALT_Per, Has_Perms_By_Name(N'dbo.Priority', 'Object', 'VIEW DEFINITION') as View_def_Per, Has_Perms_By_Name(N'dbo.Priority', 'Object', 'CONTROL') as Contr_Per BEGIN TRANSACTION
GO
ALTER TABLE dbo.IncidentHistory
	DROP CONSTRAINT FK_IncidentHistory_IncidentStatus
GO
ALTER TABLE dbo.IncidentStatus SET (LOCK_ESCALATION = TABLE)
GO
COMMIT
select Has_Perms_By_Name(N'dbo.IncidentStatus', 'Object', 'ALTER') as ALT_Per, Has_Perms_By_Name(N'dbo.IncidentStatus', 'Object', 'VIEW DEFINITION') as View_def_Per, Has_Perms_By_Name(N'dbo.IncidentStatus', 'Object', 'CONTROL') as Contr_Per BEGIN TRANSACTION
GO
ALTER TABLE dbo.IncidentHistory
	DROP CONSTRAINT FK_IncidentHistory_IncidentOrigin
GO
ALTER TABLE dbo.IncidentOrigin SET (LOCK_ESCALATION = TABLE)
GO
COMMIT
select Has_Perms_By_Name(N'dbo.IncidentOrigin', 'Object', 'ALTER') as ALT_Per, Has_Perms_By_Name(N'dbo.IncidentOrigin', 'Object', 'VIEW DEFINITION') as View_def_Per, Has_Perms_By_Name(N'dbo.IncidentOrigin', 'Object', 'CONTROL') as Contr_Per BEGIN TRANSACTION
GO
ALTER TABLE dbo.IncidentHistory
	DROP CONSTRAINT FK_IncidentHistory_Impact
GO
ALTER TABLE dbo.Impact SET (LOCK_ESCALATION = TABLE)
GO
COMMIT
select Has_Perms_By_Name(N'dbo.Impact', 'Object', 'ALTER') as ALT_Per, Has_Perms_By_Name(N'dbo.Impact', 'Object', 'VIEW DEFINITION') as View_def_Per, Has_Perms_By_Name(N'dbo.Impact', 'Object', 'CONTROL') as Contr_Per BEGIN TRANSACTION
GO
ALTER TABLE dbo.IncidentHistory
	DROP CONSTRAINT FK_IncidentHistory_ConfigurationItem
GO
ALTER TABLE dbo.ConfigurationItem SET (LOCK_ESCALATION = TABLE)
GO
COMMIT
select Has_Perms_By_Name(N'dbo.ConfigurationItem', 'Object', 'ALTER') as ALT_Per, Has_Perms_By_Name(N'dbo.ConfigurationItem', 'Object', 'VIEW DEFINITION') as View_def_Per, Has_Perms_By_Name(N'dbo.ConfigurationItem', 'Object', 'CONTROL') as Contr_Per BEGIN TRANSACTION
GO
ALTER TABLE dbo.IncidentHistory
	DROP CONSTRAINT FK_IncidentHistory_ClosureClassification
GO
ALTER TABLE dbo.ClosureClassification SET (LOCK_ESCALATION = TABLE)
GO
COMMIT
select Has_Perms_By_Name(N'dbo.ClosureClassification', 'Object', 'ALTER') as ALT_Per, Has_Perms_By_Name(N'dbo.ClosureClassification', 'Object', 'VIEW DEFINITION') as View_def_Per, Has_Perms_By_Name(N'dbo.ClosureClassification', 'Object', 'CONTROL') as Contr_Per BEGIN TRANSACTION
GO
ALTER TABLE dbo.IncidentHistory
	DROP CONSTRAINT FK_IncidentHistory_AssigneeBusinessUnit
GO
ALTER TABLE dbo.IncidentHistory
	DROP CONSTRAINT FK_IncidentHistory_BusinessUnit
GO
ALTER TABLE dbo.BusinessUnit SET (LOCK_ESCALATION = TABLE)
GO
COMMIT
select Has_Perms_By_Name(N'dbo.BusinessUnit', 'Object', 'ALTER') as ALT_Per, Has_Perms_By_Name(N'dbo.BusinessUnit', 'Object', 'VIEW DEFINITION') as View_def_Per, Has_Perms_By_Name(N'dbo.BusinessUnit', 'Object', 'CONTROL') as Contr_Per BEGIN TRANSACTION
GO
ALTER TABLE dbo.IncidentHistory
	DROP CONSTRAINT FK_IncidentHistory_Incident
GO
ALTER TABLE dbo.Incident SET (LOCK_ESCALATION = TABLE)
GO
COMMIT
select Has_Perms_By_Name(N'dbo.Incident', 'Object', 'ALTER') as ALT_Per, Has_Perms_By_Name(N'dbo.Incident', 'Object', 'VIEW DEFINITION') as View_def_Per, Has_Perms_By_Name(N'dbo.Incident', 'Object', 'CONTROL') as Contr_Per BEGIN TRANSACTION
GO
ALTER TABLE dbo.IncidentHistory
	DROP CONSTRAINT DF_IncidentHistory_CreatedBy
GO
ALTER TABLE dbo.IncidentHistory
	DROP CONSTRAINT DF_IncidentHistory_ModifiedOn
GO
ALTER TABLE dbo.IncidentHistory
	DROP CONSTRAINT DF_IncidentHistory_CreatedDate
GO
ALTER TABLE dbo.IncidentHistory
	DROP CONSTRAINT DF_IncidentHistory_Deleted
GO
ALTER TABLE dbo.IncidentHistory
	DROP CONSTRAINT DF_IncidentHistory_InternalOrigin
GO
CREATE TABLE dbo.Tmp_IncidentHistory
	(
	IncidentHistoryID bigint NOT NULL IDENTITY (1, 1),
	IncidentID bigint NOT NULL,
	CreatedBy bigint NULL,
	Title nvarchar(256) NOT NULL,
	ContactID bigint NULL,
	IncidentStatusID bigint NOT NULL,
	UrgencyID bigint NULL,
	ImpactID bigint NULL,
	PriorityID bigint NOT NULL,
	TeamID bigint NULL,
	ClosureClassificationID bigint NULL,
	IncidentOriginID bigint NULL,
	AssigneeID bigint NULL,
	AccountID bigint NULL,
	ServiceID bigint NULL,
	ConfigurationItemID bigint NULL,
	Description nvarchar(MAX) NULL,
	Resolution nvarchar(MAX) NULL,
	Note nvarchar(MAX) NULL,
	ModifiedOn datetime NOT NULL,
	CreatedOn datetime NOT NULL,
	EndedOn datetime NOT NULL,
	Deleted bit NOT NULL,
	Conversation nvarchar(MAX) NULL,
	CustomData nvarchar(MAX) NULL,
	InternalOrigin int NULL,
	Data nvarchar(MAX) NULL,
	ModifiedBy bigint NULL
	)  ON [PRIMARY]
	 TEXTIMAGE_ON [PRIMARY]
GO
ALTER TABLE dbo.Tmp_IncidentHistory SET (LOCK_ESCALATION = TABLE)
GO
ALTER TABLE dbo.Tmp_IncidentHistory ADD CONSTRAINT
	DF_IncidentHistory_CreatedBy DEFAULT ((1)) FOR CreatedBy
GO
ALTER TABLE dbo.Tmp_IncidentHistory ADD CONSTRAINT
	DF_IncidentHistory_ModifiedOn DEFAULT (getdate()) FOR ModifiedOn
GO
ALTER TABLE dbo.Tmp_IncidentHistory ADD CONSTRAINT
	DF_IncidentHistory_CreatedDate DEFAULT (getdate()) FOR CreatedOn
GO
ALTER TABLE dbo.Tmp_IncidentHistory ADD CONSTRAINT
	DF_IncidentHistory_Deleted DEFAULT ((0)) FOR Deleted
GO
ALTER TABLE dbo.Tmp_IncidentHistory ADD CONSTRAINT
	DF_IncidentHistory_InternalOrigin DEFAULT ((0)) FOR InternalOrigin
GO
SET IDENTITY_INSERT dbo.Tmp_IncidentHistory ON
GO
IF EXISTS(SELECT * FROM dbo.IncidentHistory)
	 EXEC('INSERT INTO dbo.Tmp_IncidentHistory (IncidentHistoryID, IncidentID, CreatedBy, Title, ContactID, IncidentStatusID, UrgencyID, ImpactID, PriorityID, TeamID, ClosureClassificationID, IncidentOriginID, AssigneeID, AccountID, ServiceID, ConfigurationItemID, Description, Resolution, Note, ModifiedOn, CreatedOn, EndedOn, Deleted, Conversation, CustomData, InternalOrigin, Data, ModifiedBy)
		SELECT IncidentHistoryID, IncidentID, CreatedBy, Title, ContactID, IncidentStatusID, UrgencyID, ImpactID, PriorityID, TeamID, ClosureClassificationID, IncidentOriginID, AssigneeID, AccountID, ServiceID, ConfigurationItemID, Description, Resolution, Note, ModifiedOn, CreatedOn, EndedOn, Deleted, Conversation, CustomData, InternalOrigin, Data, ModifiedBy FROM dbo.IncidentHistory WITH (HOLDLOCK TABLOCKX)')
GO
SET IDENTITY_INSERT dbo.Tmp_IncidentHistory OFF
GO
ALTER TABLE dbo.Category_IncidentHistory
	DROP CONSTRAINT FK_Category_IncidentHistory_IncidentHistory
GO
ALTER TABLE dbo.Attachment_IncidentHistory
	DROP CONSTRAINT FK_Attachment_IncidentHistory_IncidentHistory
GO
DROP TABLE dbo.IncidentHistory
GO
EXECUTE sp_rename N'dbo.Tmp_IncidentHistory', N'IncidentHistory', 'OBJECT' 
GO
ALTER TABLE dbo.IncidentHistory ADD CONSTRAINT
	PK_IncidentHistory PRIMARY KEY CLUSTERED 
	(
	IncidentHistoryID
	) WITH( STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]

GO
ALTER TABLE dbo.IncidentHistory ADD CONSTRAINT
	FK_IncidentHistory_Incident FOREIGN KEY
	(
	IncidentID
	) REFERENCES dbo.Incident
	(
	IncidentID
	) ON UPDATE  NO ACTION 
	 ON DELETE  CASCADE 
	
GO
ALTER TABLE dbo.IncidentHistory ADD CONSTRAINT
	FK_IncidentHistory_AssigneeBusinessUnit FOREIGN KEY
	(
	TeamID
	) REFERENCES dbo.BusinessUnit
	(
	BusinessUnitID
	) ON UPDATE  NO ACTION 
	 ON DELETE  NO ACTION 
	
GO
ALTER TABLE dbo.IncidentHistory WITH NOCHECK ADD CONSTRAINT
	FK_IncidentHistory_BusinessUnit FOREIGN KEY
	(
	AccountID
	) REFERENCES dbo.BusinessUnit
	(
	BusinessUnitID
	) ON UPDATE  NO ACTION 
	 ON DELETE  NO ACTION 
	
GO
ALTER TABLE dbo.IncidentHistory
	NOCHECK CONSTRAINT FK_IncidentHistory_BusinessUnit
GO
ALTER TABLE dbo.IncidentHistory WITH NOCHECK ADD CONSTRAINT
	FK_IncidentHistory_ClosureClassification FOREIGN KEY
	(
	ClosureClassificationID
	) REFERENCES dbo.ClosureClassification
	(
	ClosureClassificationID
	) ON UPDATE  NO ACTION 
	 ON DELETE  NO ACTION 
	
GO
ALTER TABLE dbo.IncidentHistory
	NOCHECK CONSTRAINT FK_IncidentHistory_ClosureClassification
GO
ALTER TABLE dbo.IncidentHistory ADD CONSTRAINT
	FK_IncidentHistory_ConfigurationItem FOREIGN KEY
	(
	ConfigurationItemID
	) REFERENCES dbo.ConfigurationItem
	(
	ConfigurationItemID
	) ON UPDATE  NO ACTION 
	 ON DELETE  NO ACTION 
	
GO
ALTER TABLE dbo.IncidentHistory WITH NOCHECK ADD CONSTRAINT
	FK_IncidentHistory_Impact FOREIGN KEY
	(
	ImpactID
	) REFERENCES dbo.Impact
	(
	ImpactID
	) ON UPDATE  NO ACTION 
	 ON DELETE  NO ACTION 
	
GO
ALTER TABLE dbo.IncidentHistory
	NOCHECK CONSTRAINT FK_IncidentHistory_Impact
GO
ALTER TABLE dbo.IncidentHistory WITH NOCHECK ADD CONSTRAINT
	FK_IncidentHistory_IncidentOrigin FOREIGN KEY
	(
	IncidentOriginID
	) REFERENCES dbo.IncidentOrigin
	(
	IncidentOriginID
	) ON UPDATE  NO ACTION 
	 ON DELETE  NO ACTION 
	
GO
ALTER TABLE dbo.IncidentHistory
	NOCHECK CONSTRAINT FK_IncidentHistory_IncidentOrigin
GO
ALTER TABLE dbo.IncidentHistory ADD CONSTRAINT
	FK_IncidentHistory_IncidentStatus FOREIGN KEY
	(
	IncidentStatusID
	) REFERENCES dbo.IncidentStatus
	(
	IncidentStatusID
	) ON UPDATE  NO ACTION 
	 ON DELETE  NO ACTION 
	
GO
ALTER TABLE dbo.IncidentHistory ADD CONSTRAINT
	FK_IncidentHistory_Priority FOREIGN KEY
	(
	PriorityID
	) REFERENCES dbo.Priority
	(
	PriorityID
	) ON UPDATE  NO ACTION 
	 ON DELETE  NO ACTION 
	
GO
ALTER TABLE dbo.IncidentHistory ADD CONSTRAINT
	FK_IncidentHistory_Service FOREIGN KEY
	(
	ServiceID
	) REFERENCES dbo.Service
	(
	ServiceID
	) ON UPDATE  NO ACTION 
	 ON DELETE  NO ACTION 
	
GO
ALTER TABLE dbo.IncidentHistory WITH NOCHECK ADD CONSTRAINT
	FK_IncidentHistory_Urgency FOREIGN KEY
	(
	UrgencyID
	) REFERENCES dbo.Urgency
	(
	UrgencyID
	) ON UPDATE  NO ACTION 
	 ON DELETE  NO ACTION 
	
GO
ALTER TABLE dbo.IncidentHistory
	NOCHECK CONSTRAINT FK_IncidentHistory_Urgency
GO
ALTER TABLE dbo.IncidentHistory ADD CONSTRAINT
	FK_IncidentHistory_Users FOREIGN KEY
	(
	ModifiedBy
	) REFERENCES dbo.Users
	(
	UserID
	) ON UPDATE  NO ACTION 
	 ON DELETE  NO ACTION 
	
GO
ALTER TABLE dbo.IncidentHistory WITH NOCHECK ADD CONSTRAINT
	FK_IncidentHistory_Users_Assignee FOREIGN KEY
	(
	AssigneeID
	) REFERENCES dbo.Users
	(
	UserID
	) ON UPDATE  NO ACTION 
	 ON DELETE  NO ACTION 
	
GO
ALTER TABLE dbo.IncidentHistory ADD CONSTRAINT
	FK_IncidentHistory_Users_ContactID FOREIGN KEY
	(
	ContactID
	) REFERENCES dbo.Users
	(
	UserID
	) ON UPDATE  NO ACTION 
	 ON DELETE  NO ACTION 
	
GO
ALTER TABLE dbo.IncidentHistory ADD CONSTRAINT
	FK_IncidentHistory_Users_CreatedBy FOREIGN KEY
	(
	CreatedBy
	) REFERENCES dbo.Users
	(
	UserID
	) ON UPDATE  NO ACTION 
	 ON DELETE  NO ACTION 
	
GO
COMMIT
select Has_Perms_By_Name(N'dbo.IncidentHistory', 'Object', 'ALTER') as ALT_Per, Has_Perms_By_Name(N'dbo.IncidentHistory', 'Object', 'VIEW DEFINITION') as View_def_Per, Has_Perms_By_Name(N'dbo.IncidentHistory', 'Object', 'CONTROL') as Contr_Per BEGIN TRANSACTION
GO
ALTER TABLE dbo.Attachment_IncidentHistory ADD CONSTRAINT
	FK_Attachment_IncidentHistory_IncidentHistory FOREIGN KEY
	(
	IncidentHistoryID
	) REFERENCES dbo.IncidentHistory
	(
	IncidentHistoryID
	) ON UPDATE  NO ACTION 
	 ON DELETE  CASCADE 
	
GO
ALTER TABLE dbo.Attachment_IncidentHistory SET (LOCK_ESCALATION = TABLE)
GO
COMMIT
select Has_Perms_By_Name(N'dbo.Attachment_IncidentHistory', 'Object', 'ALTER') as ALT_Per, Has_Perms_By_Name(N'dbo.Attachment_IncidentHistory', 'Object', 'VIEW DEFINITION') as View_def_Per, Has_Perms_By_Name(N'dbo.Attachment_IncidentHistory', 'Object', 'CONTROL') as Contr_Per BEGIN TRANSACTION
GO
ALTER TABLE dbo.Category_IncidentHistory ADD CONSTRAINT
	FK_Category_IncidentHistory_IncidentHistory FOREIGN KEY
	(
	IncidentHistoryID
	) REFERENCES dbo.IncidentHistory
	(
	IncidentHistoryID
	) ON UPDATE  NO ACTION 
	 ON DELETE  NO ACTION 
	
GO
ALTER TABLE dbo.Category_IncidentHistory SET (LOCK_ESCALATION = TABLE)
GO
COMMIT
select Has_Perms_By_Name(N'dbo.Category_IncidentHistory', 'Object', 'ALTER') as ALT_Per, Has_Perms_By_Name(N'dbo.Category_IncidentHistory', 'Object', 'VIEW DEFINITION') as View_def_Per, Has_Perms_By_Name(N'dbo.Category_IncidentHistory', 'Object', 'CONTROL') as Contr_Per 



UPDATE [DatabaseVersion] SET [VersionNumber]='5.0.12.0'